package gov.va.med.esr.common.model.lookup;

import gov.va.med.fw.model.lookup.AbstractCode;
import gov.va.med.fw.model.lookup.AbstractNamedLookup;

public class CorrespondenceStatus extends AbstractNamedLookup {


	/**
	 *
	 */
	private static final long serialVersionUID = -2004822655108799047L;

	public static final Code  ENROLLMENT_REJECT = new Code("AX");
    public static final Code  RETURN_BY_USPS = new Code("AP");
    public static final Code  CANCEL_BY_HEC = new Code("AC");
    public static final Code  PENDING_TRANSMISSION_TO_CMS = new Code("AG");
    public static final Code  SENT_TO_CMS = new Code("AS");
    public static final Code  REJECTED_ADDRESS_BY_CMS = new Code("AR");
    public static final Code  ERROR_BY_CMS = new Code("AE");
    public static final Code  MAILED_BY_CMS = new Code("AA");
    public static final Code  CORRESPONDENCE_COMPLETE = new Code("EA");
    public static final Code  CORRESPONDENCE_FAILED = new Code("EX");

	public static class Code extends AbstractCode
	{


	private static final long serialVersionUID = 5463963733006936385L;

	private Code(String code) {
			super(code);
		}

		public static Code getByCode(String code) {
			return (Code) getCode(Code.class, code);
		}
	}


	 /**
	  * Default constructor.
	  */
	public CorrespondenceStatus() {
		super();
	}
}


