/*******************************************************************************
 * Copyright  2005 VHA. All rights reserved
 ******************************************************************************/
package gov.va.med.esr.common.model.lookup;

// Java classes

// Library classes
import gov.va.med.fw.model.lookup.AbstractCode;
import gov.va.med.fw.model.lookup.AbstractNamedActiveLookup;

// ESR classes

/**
 * This is one of the classes of the Business Object Model (BOM). This class
 * represents an EGT Setting Type.
 * 
 * @author Andrew Pach
 * @version 3.0
 */
public class EligibilityDocType extends AbstractNamedActiveLookup {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 2539089797792814764L;
	/**
	 * An instance of serialVersionUID
	 */


	public static final Code DD_214 = new Code("1");
	public static final Code DD_215 = new Code("2");	
	public static final Code WD_AGO_FORM = new Code("3");	
	public static final Code MILLITARY_ORDER_OF_AWARD = new Code("4");
	public static final Code OTHER_OFFICIAL_SERVICE_RECORDS = new Code("5");	
	public static final Code VBA_DOD_FILE = new Code("6");
	public static final Code VBA_LETTER = new Code("7");	


	public static class Code extends AbstractCode {
		/**
		 * An instance of serialVersionUID
		 */
		private static final long serialVersionUID = -5029022131116387681L;

		private Code(String code) {
			super(code);
		}

		public static Code getByCode(String code) {
			return (Code) getCode(Code.class, code);
		}
	}

	/**
	 * Default constructor.
	 */
	public EligibilityDocType() {
		super();
	}
}