package gov.va.med.esr.common.model.lookup;

import gov.va.med.esr.common.model.lookup.BenefitType.Code;
import gov.va.med.fw.model.lookup.AbstractCode;
import gov.va.med.fw.model.lookup.AbstractNamedActiveLookup;

//Java Classes

//Library Classes

//Framework Classes

/**
 * @author Commons Team
 * 
  */
public class EmploymentStatus
    extends AbstractNamedActiveLookup
{
    /**
	 * An instance of serialVersionUID
	 */
	private static final long serialVersionUID = 5752874554584891634L;

	 	public static final Code CODE_FULL_TIME = new Code("1");
	    public static final Code CODE_PART_TIME = new Code("2");
	    public static final Code CODE_NOT_EMPLOYED = new Code("3");
	    public static final Code CODE_SELF_EMPLOYED = new Code("4");
	    public static final Code CODE_RETIRED = new Code("5");
	    public static final Code CODE_ACTIVE_MILITARYSERVICE = new Code("6");
	    public static final Code CODE_UNKNOWN = new Code("9");
	  
	/**
     * Default constructor.
     */
	    public EmploymentStatus()
    {
        super();
    }
    
    public static class Code extends AbstractCode {
        /**
         * 
         */
        private static final long serialVersionUID = 1400056105534470436L;

        /**
         * An instance of serialVersionUID
         */
        
        private Code(String code) {
            super(code);
        }

        public static Code getByCode(String code) {
            return (Code) getCode(Code.class, code);
        }
    }
}