package gov.va.med.esr.common.model.lookup;

import gov.va.med.fw.model.lookup.AbstractCode;
import gov.va.med.fw.model.lookup.AbstractNamedLookup;

public class TransmissionStatus extends AbstractNamedLookup {


	/**
	 *
	 */
	private static final long serialVersionUID = -2004822655408799047L;


    public static final Code  PROCESSING = new Code("AP");
    public static final Code  ACCEPTED = new Code("AA");
    public static final Code  ACCEPTED_WITH_ERRORS = new Code("AX");
    public static final Code  REJECTED = new Code("XR");
    public static final Code  NOT_FOUND = new Code("XN");
    public static final Code  FAILED = new Code("XF");
    public static final Code  EXPIRED = new Code("XE");

	public static class Code extends AbstractCode
	{


	private static final long serialVersionUID = 5463963733006936385L;

	private Code(String code) {
			super(code);
		}

		public static Code getByCode(String code) {
			return (Code) getCode(Code.class, code);
		}
	}


	 /**
	  * Default constructor.
	  */
	public TransmissionStatus() {
		super();
	}
}


