/*****************************************************************************************
 * Copyright  2004 VHA. All rights reserved
 ****************************************************************************************/
package gov.va.med.esr.common.model.lookup;

// Framework Classes
import gov.va.med.fw.model.lookup.AbstractCode;
import gov.va.med.fw.model.lookup.AbstractNamedActiveLookup;

/**
 * Lookup class for WKF Case Activity type. Project: Common
 * 
 * @author Ghazenfer Mansoor
 * @version 1.0
 */
public class WkfIssueType extends AbstractNamedActiveLookup {

   /**
    * An instance of serialVersionUID 
    */
   private static final long serialVersionUID = 8394589884786577785L;
   
   // MADHU - CHANGE THIS TO A CORRECT CODE NAME AND DESCRIPTION
   public static final Code CODE_PLACE_HOLDER_ = new Code("PUT THE RIGHT CODE HERE");
   
   //RF Type issues for VBA processing
   public static final Code CODE_DISABILITY_CODE_IS_MISSING = new Code("RF1");
   public static final Code CODE_ENTITLEMENT_CODE_IS_INVALID = new Code("RF2");
   public static final Code CODE_NO_VERIFIED_ELIGIBILITY = new Code("RF3");
   public static final Code CODE_POTENTIAL_MATCH_ERROR = new Code("RF4");
   public static final Code CODE_POTENTIAL_MISSING_RATED_DISABILITY_CODE= new Code("RF5");
   public static final Code CODE_POTENTIAL_SC_REDUCTION = new Code("RF6");
   public static final Code CODE_DISABILITY_CODE_INVALID = new Code("RF7");
   public static final Code CODE_FUTURE_SC_EFFECTIVE_DATE= new Code("RF8");
   public static final Code CODE_VA_PENSION_AND_INELIGIBLE = new Code("RF9");
   public static final Code CODE_UNABLE_TO_PROCESS_VBA_ELIGIBILITY_MESSAGE = new Code("RF10");

   public static class Code extends AbstractCode {
      /**
       * An instance of serialVersionUID
       */
      private static final long serialVersionUID = 2045331927059113705L;

      private Code(String code) {
         super(code);
      }

      public static Code getByCode(String code) {
         return (Code)getCode(Code.class, code);
      }
   }

   /**
    * Default constructor.
    */
   public WkfIssueType() {
      super();
   }
}