/********************************************************************
 * Copyright  2007 VHA. All rights reserved
 ********************************************************************/
package gov.va.med.esr.common.report.data;

/**
 * Constants for report actions.
 *
 * @author Muddaiah Ranga
 * @version 1.0
 */
public interface ReportConstants {

    public static final String REPORT_PARAM_FROM_DATE = "fromDate";
    public static final String REPORT_PARAM_TO_DATE = "toDate";
    public static final String REPORT_PARAM_FROM_YEAR = "fromYear";
    public static final String REPORT_PARAM_TO_YEAR = "toYear";
    public static final String REPORT_PARAM_AS_OF_DATE = "asOfDate";
    public static final String REPORT_PARAM_BEGIN_INCOME_YEAR = "beginIncomeYear";
    public static final String REPORT_PARAM_END_INCOME_YEAR = "endIncomeYear";
    public static final String REPORT_PARAM_DIVISION = "division";
    public static final String REPORT_PARAM_FUNCTIONAL_GROUP = "functionalGroup";
    public static final String REPORT_PARAM_WORK_ITEM_STATUS = "workItemStatus";
    public static final String REPORT_PARAM_WORK_ITEM_TYPE = "workItemType";
    public static final String REPORT_PARAM_RUN_REPORT_BY_USER = "runReportByUser";
    public static final String REPORT_PARAM_USER = "reportUser";
    public static final String REPORT_PARAM_ERROR_TYPE = "errorType";
    public static final String REPORT_PARAM_BATCH_NUMBER = "batchNumber";
    public static final String REPORT_PARAM_EXCEPTION_TYPE = "exceptionType";
    public static final String REPORT_PARAM_BAD_ADDRESS_REASON = "badAddressReason";
    public static final String REPORT_PARAM_CANCELLED_DECLINED_REASON = "cancelDeclineReason";
    public static final String REPORT_PARAM_PH_REJECT_REASON = "phRejectReason";
    public static final String REPORT_PARAM_INCLUDE_USERS = "includeUsers";
    public static final String REPORT_PARAM_MESSAGE_TYPE = "messageType";
    public static final String REPORT_PARAM_VOA_FORM_TYPES = "voaFormTypes";
    public static final String REPORT_PARAM_MESSAGE_ERROR = "messageError";
    public static final String REPORT_PARAM_PRIORITY_GROUP = "priorityGroup";
    public static final String REPORT_PARAM_ENROLLMENT_STATUS = "enrollmentStatus";
    public static final String REPORT_PARAM_PENDING_ENROLLMENT_STATUS = "pendingEnrollmentStatus";
    public static final String REPORT_PARAM_LETTER_REJECT_ERROR_REASON = "letterRejectErrorReason";
    public static final String REPORT_PARAM_ENROLLMENT_CATEGORY = "enrollmentCategory";
    public static final String REPORT_PARAM_ENROLLMENT_EFFECTIVE_DATE_CHANGE = "enrollmentEffectiveDateChange";
    public static final String REPORT_PARAM_DAYS_BETWEEN_UPDATES = "daysBetweenUpdates";
    public static final String REPORT_PARAM_CUURENT_STATUS_DAYS = "currentStatusDays";
    public static final String REPORT_PARAM_RECORDS_PER_ENROLLMENT_STATUS = "recordsPerEnrollmentStatus";
    public static final String REPORT_PARAM_REPORTS = "reports";
    public static final String REPORT_PARAM_QUERY_TO = "queryTo";
    public static final String REPORT_PARAM_VBA_QUERY_STATUS = "vbaQueryStatus";
    public static final String REPORT_PARAM_REPORT_FORMAT = "reportFormat";
    public static final String REPORT_PARAM_REPORT_DETAIL_BY = "reportDetailBy";
    public static final String REPORT_PARAM_UPDATE_STATUS = "updateStatus";
    public static final String REPORT_PARAM_EED_WEEKLY_REPORT = "eedWeeklyReport";
    public static final String REPORT_PARAM_ENROLLMENT_OVERRIDE_REASON = "enrollmentOverrideReason";

    public static final String REPORT_PARAM_REPORT_PERIOD_TYPE = "reportPeriodType";
    public static final String REPORT_PARAM_REPORT_PERIOD_START_DATE = "reportPeriodStartDate";
    public static final String REPORT_PARAM_REPORT_PERIOD_END_DATE = "reportPeriodEndDate";
    public static final String REPORT_PARAM_REPORT_PERIOD_YEAR = "reportPeriodYear";
    public static final String REPORT_PARAM_REPORT_PERIOD_QUARTER_YEAR = "reportPeriodQuarterYear";

    public static final String REPORT_PARAM_REGISTRY_TYPE = "registryType";
    public static final String REPORT_PARAM_ADDRESS_UPDATED_MULTIPLE_TIMES_WITHIN = "addressUpdatedMultipleTimesWithin";
    public static final String REPORT_PARAM_PH_CONFIRMED_FOR_MORE_THAN = "phUnconfirmedForMoreThan";
    public static final String REPORT_PARAM_LETTER_FILE = "letterFile";
    public static final String REPORT_PARAM_LETTER_FILE_RECEIVED_DATE = "letterFileReceivedDate";
    public static final String REPORT_PARAM_SUBTOTAL_DETAIL_LEVEL = "subtotalDetailLevel";
    public static final String REPORT_PARAM_RUN_REPORT_FOR = "runReportFor";

    public static final String REPORT_PARAM_FACILITY_DISPLAY_BY = "facilityDisplayBy";
    public static final String REPORT_PARAM_FACILITIES = "facilities";
    public static final String REPORT_PARAM_VISN = "visn";

    public static final String REPORT_PARAM_FILE_TYPE = "fileType";
    public static final String REPORT_PARAM_GENERATE_REPORT = "generateReport";
    public static final String REPORT_PARAM_SCHEDULE_TYPE = "scheduleType";
    public static final String REPORT_PARAM_DAILY_WEEKLY_DAY = "dailyWeeklyDay";
    public static final String REPORT_PARAM_YEARLY_DAY_OF_MONTH = "yearlyDayOfMonth";

    public static final String REPORT_PARAM_OTHER_DATE_TO_GENERATE_REPORT = "otherDateToGenerateReport";
    public static final String REPORT_PARAM_TIME_TO_GENERATE_REPORT = "timeToGenerateReport";
    public static final String REPORT_PARAM_EMAIL_REPORT_TO = "emailReportTo";

    public static final String REPORT_PARAM_OUTLIER_DAYS = "outlierDays";
    public static final String REPORT_PARAM_RANDOM_NUMBER_OF_RECORDS = "randomNumberOfRecords";
    public static final String REPORT_PARAM_ENROLLMENT_STATUS_COMPONENT = "enrollmentStatusComponent";
    public static final String REPORT_PARAM_ENROLLMENT_PROCESS_STATUS = "enrollmentProcessStatus";
    public static final String REPORT_PARAM_PERSON_MERGE_STATUS = "personMergeStatus";
    public static final String REPORT_PARAM_ELIGIBILITY_FACTOR = "eligibilityFactors";
    
    public static final String REPORT_PARAM_INCOMPLETE_REG_USER_NAME = "incompleteRegUserName";
    public static final String ACTIVE="Active";
    public static final String ARCHIVED="Archived";
}
