package gov.va.med.esr.service;

import java.io.Serializable;
import java.sql.Timestamp;

/**
 * General Purpose parameter object for E&E
 *
 * @author Carlos Ruiz
 * @version 1.0
 */
public class EEResultInfo implements Serializable {
    /**
     *
     */
    private static final long serialVersionUID = -293677323805849064L;

    private boolean z10Sent = false;

    private Timestamp effectiveDate = null;
    private Integer overrideFlag = null;
    private String groupCode = null;
    private String statusCode = null;
    private String errorReason = null;

	public EEResultInfo() {
        super();
    }

    /**
     * @return Returns the z10Sent.
     */
    public boolean isZ10Sent() {
        return z10Sent;
    }

    /**
     * @param sent The z10Sent to set.
     */
    public void setZ10Sent(boolean sent) {
        z10Sent = sent;
    }

    public Timestamp getEffectiveDate() {
        return effectiveDate;
    }

    public void setEffectiveDate(Timestamp effectiveDate) {
        this.effectiveDate = effectiveDate;
    }

    public String getGroupCode() {
        return groupCode;
    }

    public void setGroupCode(String groupCode) {
        this.groupCode = groupCode;
    }

    public Integer getOverrideFlag() {
        return overrideFlag;
    }

    public void setOverrideFlag(Integer overrideFlag) {
        this.overrideFlag = overrideFlag;
    }

    public String getStatusCode() {
        return statusCode;
    }

    public void setStatusCode(String statusCode) {
        this.statusCode = statusCode;
    }

    public String getCLVErrorReason() {
		return errorReason;
	}

	public void setCLVErrorReason(String errorReason) {
		this.errorReason = errorReason;
	}

}
