package gov.va.med.esr.service.external.person;

import gov.va.med.esr.service.external.ExternalComponent;

public class CDProcedureInfo extends ExternalComponent {

	private static final long serialVersionUID = 1006982710775984512L;

	//ZCD/8/Z11
	private String procedure = null;

	/**
	 * Affected extremity refers to the data collected for Catastrophically
	 * Disabled clinical determination. It is an affected extremity that is valid
	 * for the procedure.This is a set of codes: 'RUE' FOR Right Upper Extremity;
	 * 'LUE' FOR Left Upper Extremity 'RLE' FOR Right Lower Extremity; 'LLE' FOR
	 * Left Lower Extremity; Procedure codes indicate upper or lower extremity so
	 * for each procedure code only applicable affected extremities will be
	 * valid.(i.e. 27880 amputation of lower leg can have either RLE or LLE
	 * entered as an appropriate affected extremity)
	 * ZCD/9/Z11
	 */
	private String affectedExtremity = null;

	public String getAffectedExtremity() {
		return affectedExtremity;
	}

	public void setAffectedExtremity(String affectedExtremity) {
		this.affectedExtremity = affectedExtremity;
	}

	public String getProcedure() {
		return procedure;
	}

	public void setProcedure(String procedure) {
		this.procedure = procedure;
	}
}
