// Package 
package gov.va.med.fw.service;

/**
 * A service exception that indicates that a CLEAR import record is considered processed successfully,
 * but needs to Create an exception record with reason 
 *
 * @author George Tsai
 */
public class CLEARImportSuccessErrorReportException extends ServiceException
{
	/**
	* An instance of serialVersionUID 
	*/
	private static final long serialVersionUID = -4065103064135303029L;


   /**
     * Default constructor.  A default message will be used.
     */
    public CLEARImportSuccessErrorReportException()
    {
        super();
    }

    /**
     * Constructs a <code>EntityNotChangedException</code> with the specified detail message.
     *
     * @param msg the detail message.
     */
    public CLEARImportSuccessErrorReportException(String msg)
    {
        super(msg);
    }

    /**
     * Constructs a <code>EntityNotChangedException</code> with the specified detail message and a caused exception.
     *
     * @param msg the detail message.
     * @param cause the caused exception
     */
    public CLEARImportSuccessErrorReportException(String msg, Throwable cause)
    {
        super(msg, cause);
    }
}
