/*******************************************************************************
 * Copyright  2004 VHA. All rights reserved
 ******************************************************************************/
package gov.va.med.fw.service.event;

/**
 * A service event that is processed on a different thread in an
 * AbstractListenerService. Client application events should extend from this
 * class if asynchronous event processing behaviour is desired.
 * 
 * @author Vu Le
 * @version 1.0
 */
public class AsynchServiceEvent extends ServiceEvent implements Asynchronous {

	/**
	 * An instance of serialVersionUID
	 */
	private static final long serialVersionUID = 241492761060657369L;

	/**
	 * An event triggered by the specific source
	 * 
	 * @param source A source of an event
	 */
	public AsynchServiceEvent(Object source) {
		super(source);
	}
}
