<?xml version="1.0" encoding="UTF-8" ?>
<xsl:stylesheet version="1.0" 
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
    xmlns:hl7typ="urn:esr-vha-gov:internal:xslt:hl7-types" 
    xmlns:zseg="urn:esr-vha-gov:internal:xslt:z-segments" 
    extension-element-prefixes="hl7typ zseg" 
    xmlns:wns="urn:esr-vha-gov:internal:working-namespace" 
    exclude-result-prefixes="wns" 
    xmlns="urn:esr-vha-gov:internal:hl7-messages">
<!--	
  <xsl:import href="edb/messaging/hl7/xslt/HL7Types.xslt" />
-->
  <!--**********************************************************************-->
  <!--******************************* ZBT **********************************-->
  <xsl:template match="wns:zbt.1" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:si.element" />
  </xsl:template>

  <xsl:template match="wns:zbt.2" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:ts.element" />
  </xsl:template>

  <xsl:template match="wns:zbt.3" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zbt.4" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:nm.element" />
  </xsl:template>

  <xsl:template match="wns:zbt.5" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zbt.6" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zbt.7" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:ts.element" />
  </xsl:template>

  <!--**********************************************************************-->
  <!--******************************* ZCD **********************************-->
  <xsl:template match="wns:zcd.1" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:si.element" />
  </xsl:template>

  <xsl:template match="wns:zcd.2" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:dt.element" />
  </xsl:template>

  <xsl:template match="wns:zcd.3" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:st.element" />
  </xsl:template>

  <xsl:template match="wns:zcd.4" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:id.element" />
  </xsl:template>

  <xsl:template match="wns:zcd.5" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:dt.element" />
  </xsl:template>

  <xsl:template match="wns:zcd.6" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:ce.element" />
  </xsl:template>

  <xsl:template match="wns:zcd.7" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:ce.element" />
  </xsl:template>

  <xsl:template match="wns:zcd.8" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:ce.element" />
  </xsl:template>

  <xsl:template match="wns:zcd.9" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:ce.element" />
  </xsl:template>

  <xsl:template match="wns:zcd.10" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:ce.element" />
  </xsl:template>

  <xsl:template match="wns:zcd.11" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:st.element" />
  </xsl:template>

  <xsl:template match="wns:zcd.12" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:id.element" />
  </xsl:template>

  <xsl:template match="wns:zcd.13" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:ce.element" />
  </xsl:template>

  <xsl:template match="wns:zcd.14" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:dt.element" />
  </xsl:template>
  
    <xsl:template match="wns:zcd.15" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:dt.element" />
  </xsl:template>
  
    <xsl:template match="wns:zcd.16" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:dt.element" />
  </xsl:template>
  
   <xsl:template match="wns:zcd.17" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:ce.element" />
  </xsl:template>
  
  
  <!--**********************************************************************-->
  <!--******************************* ZCT **********************************-->
  <xsl:template match="wns:zct.1" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:si.element" />
  </xsl:template>

  <xsl:template match="wns:zct.2" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:id.element" />
  </xsl:template>

  <xsl:template match="wns:zct.3" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:xpn.element" />
  </xsl:template>

  <xsl:template match="wns:zct.4" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:st.element" />
  </xsl:template>

  <xsl:template match="wns:zct.5" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:ad.element" />
  </xsl:template>

  <xsl:template match="wns:zct.6" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:tn.element" />
  </xsl:template>

  <xsl:template match="wns:zct.7" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:tn.element" />
  </xsl:template>

  <xsl:template match="wns:zct.8" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zct.9" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>
  
  <xsl:template match="wns:zct.10" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:ts.element" />
  </xsl:template>
  

  <!--**********************************************************************-->
  <!--******************************* ZDP **********************************-->
  <xsl:template match="wns:zdp.1" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:si.element" />
  </xsl:template>

  <xsl:template match="wns:zdp.2" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:pn.element" />
  </xsl:template>

  <xsl:template match="wns:zdp.3" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:id.element" />
  </xsl:template>

  <xsl:template match="wns:zdp.4" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:dt.element" />
  </xsl:template>

  <xsl:template match="wns:zdp.5" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:st.element" />
  </xsl:template>

  <xsl:template match="wns:zdp.6" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zdp.7" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:nm.element" />
  </xsl:template>

  <xsl:template match="wns:zdp.8" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:st.element" />
  </xsl:template>

  <xsl:template match="wns:zdp.9" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:dt.element" />
  </xsl:template>

  <xsl:template match="wns:zdp.10" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:st.element" />
  </xsl:template>
  
  <xsl:template match="wns:zdp.11" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:dt.element" />
  </xsl:template>
  
  <xsl:template match="wns:zdp.12" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:st.element" />
  </xsl:template>    
  
  <xsl:template match="wns:zdp.13" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:xad.element" />
  </xsl:template>    
 
   <xsl:template match="wns:zdp.14" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:xtn.element" />
  </xsl:template>    
  
  <!--**********************************************************************-->
  <!--******************************* ZEG **********************************-->
  <xsl:template match="wns:zeg.1" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:ce.element" />
  </xsl:template>

  <xsl:template match="wns:zeg.2" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:dt.element" />
  </xsl:template>

  <xsl:template match="wns:zeg.3" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:ce.element" />
  </xsl:template>

  <xsl:template match="wns:zeg.4" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:st.element" />
  </xsl:template>

  <xsl:template match="wns:zeg.5" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:ts.element" />
  </xsl:template>

  <xsl:template match="wns:zeg.6" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:dt.element" />
  </xsl:template>

  <xsl:template match="wns:zeg.7" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:ce.element" />
  </xsl:template>

  <!--**********************************************************************-->
  <!--******************************* ZEL **********************************-->
  <xsl:template match="wns:zel.1" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:si.element" />
  </xsl:template>

  <xsl:template match="wns:zel.2" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zel.3" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:ck.element" />
  </xsl:template>

  <xsl:template match="wns:zel.4" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:st.element" />
  </xsl:template>

  <xsl:template match="wns:zel.5" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zel.6" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:nm.element" />
  </xsl:template>

  <xsl:template match="wns:zel.7" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:st.element" />
  </xsl:template>

  <xsl:template match="wns:zel.8" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zel.9" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:st.element" />
  </xsl:template>

  <xsl:template match="wns:zel.10" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zel.11" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:dt.element" />
  </xsl:template>

  <xsl:template match="wns:zel.12" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:dt.element" />
  </xsl:template>

  <xsl:template match="wns:zel.13" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:st.element" />
  </xsl:template>

  <xsl:template match="wns:zel.14" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zel.15" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zel.16" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zel.17" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zel.18" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zel.19" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zel.20" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zel.21" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:nm.element" />
  </xsl:template>

  <xsl:template match="wns:zel.22" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zel.23" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zel.24" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:ts.element" />
  </xsl:template>

  <xsl:template match="wns:zel.25" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zel.26" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:dt.element" />
  </xsl:template>

  <xsl:template match="wns:zel.27" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:dt.element" />
  </xsl:template>

  <xsl:template match="wns:zel.28" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:nm.element" />
  </xsl:template>

  <xsl:template match="wns:zel.29" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:ce.element" />
  </xsl:template>

  <xsl:template match="wns:zel.30" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:dt.element" />
  </xsl:template>

  <xsl:template match="wns:zel.31" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:dt.element" />
  </xsl:template>

  <xsl:template match="wns:zel.32" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:dt.element" />
  </xsl:template>

  <xsl:template match="wns:zel.33" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:dt.element" />
  </xsl:template>

  <xsl:template match="wns:zel.34" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:dt.element" />
  </xsl:template>

  <xsl:template match="wns:zel.35" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <!--<xsl:template match="wns:zel.36" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:??.element" />
  </xsl:template>-->

  <xsl:template match="wns:zel.37" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zel.38" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:dt.element" />
  </xsl:template>
  
  <!--**********************************************************************-->
  <!--******************************* ZE2 **********************************-->
  
  <xsl:template match="wns:ze2.1" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:ce.element" />
  </xsl:template>

  <xsl:template match="wns:ze2.2" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:ce.element" />
  </xsl:template>  
  
  <xsl:template match="wns:ze2.3" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:ce.element" />
  </xsl:template>

  <!--**********************************************************************-->
  <!--******************************* ZEM **********************************-->
  <xsl:template match="wns:zem.1" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:si.element" />
  </xsl:template>

  <xsl:template match="wns:zem.2" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:id.element" />
  </xsl:template>

  <xsl:template match="wns:zem.3" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zem.4" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:st.element" />
  </xsl:template>

  <xsl:template match="wns:zem.5" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:st.element" />
  </xsl:template>

  <xsl:template match="wns:zem.6" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:ad.element" />
  </xsl:template>

  <xsl:template match="wns:zem.7" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:tn.element" />
  </xsl:template>

  <xsl:template match="wns:zem.8" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zem.9" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:dt.element" />
  </xsl:template>

  <!--**********************************************************************-->
  <!--******************************* ZEN **********************************-->
  <xsl:template match="wns:zen.1" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:si.element" />
  </xsl:template>

  <xsl:template match="wns:zen.2" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:dt.element" />
  </xsl:template>

  <xsl:template match="wns:zen.3" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:id.element" />
  </xsl:template>

  <xsl:template match="wns:zen.4" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zen.5" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zen.6" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:tx.element" />
  </xsl:template>

  <xsl:template match="wns:zen.7" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zen.8" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zen.9" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zen.10" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:dt.element" />
  </xsl:template>

  <xsl:template match="wns:zen.11" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:dt.element" />
  </xsl:template>

  <xsl:template match="wns:zen.12" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:dt.element" />
  </xsl:template>

  <xsl:template match="wns:zen.13" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <!--**********************************************************************-->
  <!--******************************* ZFE **********************************-->
  <xsl:template match="wns:zfe.1" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:si.element" />
  </xsl:template>

  <xsl:template match="wns:zfe.2" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:ce.element" />
  </xsl:template>

  <xsl:template match="wns:zfe.3" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:ce.element" />
  </xsl:template>

  <xsl:template match="wns:zfe.4" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:dt.element" />
  </xsl:template>

  <xsl:template match="wns:zfe.5" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:dt.element" />
  </xsl:template>

  <!--**********************************************************************-->
  <!--******************************* ZGD **********************************-->
  <xsl:template match="wns:zgd.1" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:si.element" />
  </xsl:template>

  <xsl:template match="wns:zgd.2" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:id.element" />
  </xsl:template>

  <xsl:template match="wns:zgd.3" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:st.element" />
  </xsl:template>

  <xsl:template match="wns:zgd.4" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:st.element" />
  </xsl:template>

  <xsl:template match="wns:zgd.5" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:st.element" />
  </xsl:template>

  <xsl:template match="wns:zgd.6" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:ad.element" />
  </xsl:template>

  <xsl:template match="wns:zgd.7" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:tn.element" />
  </xsl:template>

  <xsl:template match="wns:zgd.8" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:dt.element" />
  </xsl:template>

  <!--**********************************************************************-->
  <!--******************************* ZIC **********************************-->
  <xsl:template match="wns:zic.1" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:si.element" />
  </xsl:template>

  <xsl:template match="wns:zic.2" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:dt.element" />
  </xsl:template>

  <xsl:template match="wns:zic.3" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:nm.element" />
  </xsl:template>

  <xsl:template match="wns:zic.4" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:nm.element" />
  </xsl:template>

  <xsl:template match="wns:zic.5" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:nm.element" />
  </xsl:template>

  <xsl:template match="wns:zic.6" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:nm.element" />
  </xsl:template>

  <xsl:template match="wns:zic.7" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:nm.element" />
  </xsl:template>

  <xsl:template match="wns:zic.8" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:nm.element" />
  </xsl:template>

  <xsl:template match="wns:zic.9" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:nm.element" />
  </xsl:template>

  <xsl:template match="wns:zic.10" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:nm.element" />
  </xsl:template>

  <xsl:template match="wns:zic.11" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:nm.element" />
  </xsl:template>

  <xsl:template match="wns:zic.12" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:nm.element" />
  </xsl:template>

  <xsl:template match="wns:zic.13" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:nm.element" />
  </xsl:template>

  <xsl:template match="wns:zic.14" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:nm.element" />
  </xsl:template>

  <xsl:template match="wns:zic.15" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:nm.element" />
  </xsl:template>

  <xsl:template match="wns:zic.16" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:nm.element" />
  </xsl:template>

  <xsl:template match="wns:zic.17" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:nm.element" />
  </xsl:template>

  <xsl:template match="wns:zic.18" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:nm.element" />
  </xsl:template>

  <xsl:template match="wns:zic.19" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:nm.element" />
  </xsl:template>

  <xsl:template match="wns:zic.20" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:nm.element" />
  </xsl:template>

  <xsl:template match="wns:zic.21" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:dt.element" />
  </xsl:template>

  <xsl:template match="wns:zic.22" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:nm.element" />
  </xsl:template>

  <xsl:template match="wns:zic.23" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <!--**********************************************************************-->
  <!--******************************* ZIE **********************************-->
  <xsl:template match="wns:zie.1" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:si.element" />
  </xsl:template>

  <xsl:template match="wns:zie.2" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:dt.element" />
  </xsl:template>

  <xsl:template match="wns:zie.3" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:st.element" />
  </xsl:template>

  <xsl:template match="wns:zie.4" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:st.element" />
  </xsl:template>

  <xsl:template match="wns:zie.5" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:st.element" />
  </xsl:template>

  <xsl:template match="wns:zie.6" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:id.element" />
  </xsl:template>

  <xsl:template match="wns:zie.7" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:id.element" />
  </xsl:template>

  <!--**********************************************************************-->
  <!--******************************* ZIO **********************************-->
  <xsl:template match="wns:zio.1" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:si.element" />
  </xsl:template>

  <xsl:template match="wns:zio.2" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:nm.element" />
  </xsl:template>

  <xsl:template match="wns:zio.3" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:nm.element" />
  </xsl:template>

  <xsl:template match="wns:zio.4" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:dt.element" />
  </xsl:template>

  <!--**********************************************************************-->
  <!--******************************* ZIR **********************************-->
  <xsl:template match="wns:zir.1" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:si.element" />
  </xsl:template>

  <xsl:template match="wns:zir.2" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zir.3" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zir.4" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:nm.element" />
  </xsl:template>

  <xsl:template match="wns:zir.5" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zir.6" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zir.7" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zir.8" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zir.9" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zir.10" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:nm.element" />
  </xsl:template>
  
   <xsl:template match="wns:zir.11" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:nm.element" />
  </xsl:template>

  <!--**********************************************************************-->
  <!--******************************* ZIV **********************************-->
  <xsl:template match="wns:ziv.1" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:si.element" />
  </xsl:template>

  <xsl:template match="wns:ziv.2" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:dt.element" />
  </xsl:template>

  <xsl:template match="wns:ziv.3" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:id.element" />
  </xsl:template>

  <xsl:template match="wns:ziv.4" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:st.element" />
  </xsl:template>
  
  <xsl:template match="wns:ziv.5" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:id.element" />
  </xsl:template>

  <xsl:template match="wns:ziv.6" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:st.element" />
  </xsl:template>

  <xsl:template match="wns:ziv.7" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:ck.element" />
  </xsl:template>

  <xsl:template match="wns:ziv.8" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:id.element" />
  </xsl:template>
  
  <xsl:template match="wns:ziv.9" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:ck.element" />
  </xsl:template>

  <xsl:template match="wns:ziv.10" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:id.element" />
  </xsl:template>

  <xsl:template match="wns:ziv.11" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:id.element" />
  </xsl:template>

  <xsl:template match="wns:ziv.12" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:ts.element" />
  </xsl:template>
  
  <!--**********************************************************************-->
  <!--******************************* ZMH **********************************-->
  <xsl:template match="wns:zmh.1" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:si.element" />
  </xsl:template>

  <xsl:template match="wns:zmh.2" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zmh.3" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:ce.element" />
  </xsl:template>

  <xsl:template match="wns:zmh.4" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:dr.element" />
  </xsl:template>

  <!--**********************************************************************-->
  <!--******************************* ZMT **********************************-->
  <xsl:template match="wns:zmt.1" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:si.element" />
  </xsl:template>

  <xsl:template match="wns:zmt.2" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:dt.element" />
  </xsl:template>

  <xsl:template match="wns:zmt.3" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zmt.4" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:nm.element" />
  </xsl:template>

  <xsl:template match="wns:zmt.5" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:nm.element" />
  </xsl:template>

  <xsl:template match="wns:zmt.6" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:ts.element" />
  </xsl:template>

  <xsl:template match="wns:zmt.7" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zmt.8" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:nm.element" />
  </xsl:template>

  <xsl:template match="wns:zmt.9" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:nm.element" />
  </xsl:template>

  <xsl:template match="wns:zmt.10" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:ts.element" />
  </xsl:template>

  <xsl:template match="wns:zmt.11" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zmt.12" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:nm.element" />
  </xsl:template>

  <xsl:template match="wns:zmt.13" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zmt.14" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:dt.element" />
  </xsl:template>

  <xsl:template match="wns:zmt.15" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:ts.element" />
  </xsl:template>

  <xsl:template match="wns:zmt.16" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zmt.17" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zmt.18" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:id.element" />
  </xsl:template>

  <xsl:template match="wns:zmt.19" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zmt.20" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:dt.element" />
  </xsl:template>

  <xsl:template match="wns:zmt.21" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zmt.22" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zmt.23" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zmt.24" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:dt.element" />
  </xsl:template>

  <xsl:template match="wns:zmt.25" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:ts.element" />
  </xsl:template>

  <xsl:template match="wns:zmt.26" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zmt.27" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zmt.28" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:nm.element" />
  </xsl:template>

  <xsl:template match="wns:zmt.29" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:ft.element" />
  </xsl:template>

  <xsl:template match="wns:zmt.30" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:ft.element" />
  </xsl:template>
  
  <xsl:template match="wns:zmt.31" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:ft.element" />
  </xsl:template>  

  <!--**********************************************************************-->
  <!--******************************* ZPD **********************************-->
  <xsl:template match="wns:zpd.1" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:si.element" />
  </xsl:template>

  <xsl:template match="wns:zpd.2" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:st.element" />
  </xsl:template>

  <xsl:template match="wns:zpd.3" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:st.element" />
  </xsl:template>

  <xsl:template match="wns:zpd.4" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:st.element" />
  </xsl:template>

  <xsl:template match="wns:zpd.5" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zpd.6" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:st.element" />
  </xsl:template>

  <xsl:template match="wns:zpd.7" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:st.element" />
  </xsl:template>

  <xsl:template match="wns:zpd.8" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zpd.9" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:ts.element" />
  </xsl:template>

  <xsl:template match="wns:zpd.10" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:pn.element" />
  </xsl:template>

  <xsl:template match="wns:zpd.11" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zpd.12" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zpd.13" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:ts.element" />
  </xsl:template>

  <xsl:template match="wns:zpd.14" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zpd.15" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zpd.16" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zpd.17" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:st.element" />
  </xsl:template>

  <xsl:template match="wns:zpd.18" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zpd.19" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zpd.20" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:st.element" />
  </xsl:template>

  <xsl:template match="wns:zpd.21" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:st.element" />
  </xsl:template>

  <xsl:template match="wns:zpd.22" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zpd.23" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:nm.element" />
  </xsl:template>

  <xsl:template match="wns:zpd.24" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:dt.element" />
  </xsl:template>

  <xsl:template match="wns:zpd.25" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:st.element" />
  </xsl:template>

  <xsl:template match="wns:zpd.26" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:dt.element" />
  </xsl:template>

  <xsl:template match="wns:zpd.27" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:st.element" />
  </xsl:template>

  <xsl:template match="wns:zpd.28" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:dt.element" />
  </xsl:template>

  <xsl:template match="wns:zpd.29" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:dt.element" />
  </xsl:template>

  <xsl:template match="wns:zpd.30" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:id.element" />
  </xsl:template>

  <xsl:template match="wns:zpd.31" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zpd.32" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:ts.element" />
  </xsl:template>

  <xsl:template match="wns:zpd.33" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zpd.41" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:st.element" />
  </xsl:template>

  <!--**********************************************************************-->
  <!--******************************* ZRD **********************************-->
  <xsl:template match="wns:zrd.1" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:si.element" />
  </xsl:template>

  <xsl:template match="wns:zrd.2" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:ce.element" />
  </xsl:template>

  <xsl:template match="wns:zrd.3" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:nm.element" />
  </xsl:template>

  <xsl:template match="wns:zrd.4" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <!--**********************************************************************-->
  <!--******************************* ZSP **********************************-->
  <xsl:template match="wns:zsp.1" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:si.element" />
  </xsl:template>

  <xsl:template match="wns:zsp.2" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zsp.3" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:nm.element" />
  </xsl:template>

  <xsl:template match="wns:zsp.4" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zsp.5" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:st.element" />
  </xsl:template>

  <xsl:template match="wns:zsp.6" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zsp.7" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zsp.8" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:ts.element" />
  </xsl:template>

  <xsl:template match="wns:zsp.9" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:dt.element" />
  </xsl:template>

  <xsl:template match="wns:zsp.10" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:dt.element" />
  </xsl:template>
  
  <!--**********************************************************************-->
  <!--******************************* ZTA **********************************-->
  <xsl:template match="wns:zta.1" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:si.element" />
  </xsl:template>

  <xsl:template match="wns:zta.2" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:is.element" />
  </xsl:template>

  <xsl:template match="wns:zta.3" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:dt.element" />
  </xsl:template>

  <xsl:template match="wns:zta.4" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:dt.element" />
  </xsl:template>

  <xsl:template match="wns:zta.5" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:xad.element" />
  </xsl:template>

  <xsl:template match="wns:zta.6" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:id.element" />
  </xsl:template>

  <xsl:template match="wns:zta.7" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:tn.element" />
  </xsl:template>
  
  <xsl:template match="wns:zta.8" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:ts.element" />
  </xsl:template>
  
  <!--**********************************************************************-->
  <!--******************************* ZHP **********************************-->
  <xsl:template match="wns:zhp.1" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:si.element" />
  </xsl:template>

  <xsl:template match="wns:zhp.2" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:id.element" />
  </xsl:template>

  <xsl:template match="wns:zhp.3" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:ts.element" />
  </xsl:template>
 
  <xsl:template match="wns:zhp.4" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:st.element" />
  </xsl:template>

  <xsl:template match="wns:zhp.5" mode="hl7typ:fields">
    <xsl:call-template name="hl7typ:id.element" />
  </xsl:template>
  
 </xsl:stylesheet>
