<?xml version="1.0" encoding="UTF-8" ?>
<xsl:stylesheet version="1.0" 
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
    xmlns:hl7typ="urn:esr-vha-gov:internal:xslt:hl7-types" 
    extension-element-prefixes="hl7typ" 
    xmlns:wns="urn:esr-vha-gov:internal:working-namespace" 
    exclude-result-prefixes="wns" 
    xmlns="urn:esr-vha-gov:internal:hl7-messages" 
    xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
<!--	
  <xsl:import href="edb/messaging/hl7/xslt/HL7Messages.xslt" />
  <xsl:import href="edb/messaging/hl7/xslt/HL7Segments.xslt" />
  <xsl:import href="edb/messaging/hl7/xslt/ZSegments.xslt" />
-->
  <xsl:include href="edb/messaging/hl7/xslt/HL7Messages.xslt" />
  <xsl:include href="edb/messaging/hl7/xslt/HL7Segments.xslt" />
  <xsl:include href="edb/messaging/hl7/xslt/HL7Types.xslt" />
  <xsl:include href="edb/messaging/hl7/xslt/Utilities.xslt" />
  <xsl:include href="edb/messaging/hl7/xslt/ZSegments.xslt" />
	
  <xsl:output 
      method="xml" 
      version="1.0" 
      encoding="UTF-8" 
      omit-xml-declaration="no" />

  <xsl:template match="/">
    <xsl:apply-templates>
      <xsl:with-param name="messageName" select="'batch'" />
      <xsl:with-param name="isBatch" select="true()" />
    </xsl:apply-templates>
  </xsl:template>

  <xsl:template match="wns:*[not(((local-name() = 'bhs') and (position() = 1)) or ((local-name() = 'bts') and (last())))]" mode="hl7typ:segments">
    <xsl:param name="fieldDelimiter" />
    <xsl:param name="componentDelimiter" />
    <xsl:param name="subComponentDelimiter" />
    <xsl:param name="repeatingFieldDelimiter" />
    <xsl:param name="escapeCharacter" />

  </xsl:template>
</xsl:stylesheet>
