/********************************************************************
 * Copyright  2005 VHA. All rights reserved
 ********************************************************************/
package gov.va.med.esr.ui;

/**
 * Application constants used throughout the UI
 */
public interface ApplicationConstants
{
    public interface Labels
    {
        public static final String YES = "label.yes";
        public static final String NO = "label.no";
        public static final String NO_DATA = "label.noData";
        public static final String TRUE = "label.true";
        public static final String FALSE = "label.false";
    }

    public interface ServiceRequests
    {
        // Request Names
        public static final String SEARCH_PERSON_REQUEST = "personSearchRequest";
        public static final String FIND_PERSON_REQUEST = "personFindRequest";
        public static final String GET_PERSON_REQUEST = "personGetRequest";

        public static final String GET_MSGLOG_REQUEST = "msgLogGetRequest";
        public static final String FIND_MSGLOG_REQUEST = "msgLogFindRequest";
    }

    public interface MessageKeys
    {
    	public static final String ERRORS_SSN = "errors.ssn";
        public static final String ERRORS_VPID = "errors.vpid";
        public static final String ERRORS_REQUIRED = "errors.required";
        public static final String ERRORS_NOT_ALLOWED = "errors.notAllowed";
        public static final String ERRORS_INVALID = "errors.invalid";
        public static final String ERRORS_MAXLENGTH = "errors.maxlength";
        public static final String ERRORS_MINLENGTH = "errors.minlength";
        public static final String ERRORS_RANGE = "errors.range";
        public static final String ERRORS_DETAIL = "errors.detail";

        public static final String ERRORS_MAX_RECORDS_EXCEEDED = "errors.max.records.exceeded";
        public static final String ERRORS_MAX_RECORDS_EXCEEDED_RECORD_LIMIT = "errors.max.records.exceeded.recordLimit";
        public static final String ERRORS_MAX_RECORDS_EXCEEDED_NO_PARAMS = "errors.max.records.exceeded.noParams";

        public static final String ERRORS_SEARCH_NORESULT = "errors.search.noresult";
        public static final String ERRORS_VALUE_IS_REQUIRED = "errors.requiresValue";
        public static final String ERRORS_UNIT_IS_REQUIRED = "errors.requiresUnits";
        public static final String ERRORS_NUMERIC = "errors.numeric";
        public static final String ERRORS_SPCL_CHARS_NOT_ALLOWED = "error.specailCharsNotAllowed";
        public static final String ERRORS_INVALID_IMPRECISE_DATE = "errors.imprecisedate";
        public static final String ERRORS_DATE = "errors.date";
        public static final String ERRORS_INVALID_SEARCH_PERMISSION = "errors.invalid.search.permission";
        public static final String ERRORS_INVALID_FURUTE_DATE = "errors.validateDateFuture";
        public static final String ERRORS_CAPABILITY_REQUIRED = "errors.capabilityRequired";
        public static final String ERRORS_PARTIAL_DATE = "errors.partialDate";
        public static final String ERRORS_FORM_TYPE = "errors.form.type";
        public static final String ERRORS_PENDING_REASON = "errors.pending.reason";
        public static final String ERRORS_VHIC_SERVICE_CONNECTION = "errors.vhicService.connection";
        public static final String ERRORS_CL_VISTA_ROLLOUT = "error.campLejeuneVistARollout";
    }

    public interface JSPParameters
    {
        public static final String SELECTED_MSG_ID_PARAM = "selectedMsgId";
        public static final String SELECTED_PARTY_ID_PARAM = "selectedPartyId";
        public static final String SELECTED_CASE_ID_PARAM = "selectedCaseId";
        public static final String SELECTED_TBL_ID_PARAM = "selectedTableId";
    }

    public interface SessionData
    {
        public static final String MESSAGE_LIST = "MessageList";
        public static final String SEARCH_RESULT = "SearchResult";
        public static final String SELECTED_PERSON = "SelectedPerson";
        public static final String SELECTED_TRAITS = "SelectedTraits";
        public static final String UPDATED_PERSON = "UpdatedPerson";
        public static final String ELIGIBILITY_STATUS_LIST = "eligibilityStatusList";
        public static final String PURPLEHEART_STATUS_LIST = "phStatusList";
        public static final String PURPLEHEART_REJECTREMARK_LIST = "phRejectRemarkList";
        public static final String RADIATION_EXPOSURE_METHOD_LIST = "radiationExposureMethodList";
        public static final String AGENT_ORANGE_EXPOSURE_LOCATION_LIST = "AgentOrangeExposureLocationList";
        public static final String DISABILITY_RETIREMENT_LIST = "disabilityRetirementStatusList";
        public static final String EXCEPTION = "Exception";
        public static final String CURRENT_EGT_SETTING = "currentEGTSetting";
        public static final String FUTURE_EGT_SETTINGS = "futureEGTSettings";
        public static final String PRISTINE_ENTITY ="PristineEntity";
        public static final String UPDATED_ENTITY ="UpdatedEntity";
    	public final static String LOCKED_MERGE_INFO_ENTITYKEY = "LockedMergeInfoEntityKey";
        public static final String ASYNC_MESSAGES ="AsyncMessages";
        public static final String ADD_A_PERSON = "addAPerson";
        //CCR13343 SSOi integration
        //SSOi Header Attributes
        public static final String ID_HEADER = "SM_USER";
        public static final String TRANS_HEADER = "SM_TRANSACTIONID";
        public static final String DOMAIN_HEADER = "SM_SDOMAIN";
        public static final String AUTHTYPE_HEADER = "SM_AUTHTYPE";
        public static final String USER_HEADER = "SM_UNIVERSALID";
        public static final String DN_HEADER = "SM_USERDN";
        public static final String SM_VsID        {AES}F2MrPlleUOh1119rnpyEYw==";
        //public static final String EMAIL_HEADER = "Email";
        //public static final String GROUPS_HEADER = "Groups/Roles";

    }
}
