/********************************************************************
 * Copyright  2004 VHA. All rights reserved
 ********************************************************************/
package gov.va.med.esr.ui.common.beans;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import gov.va.med.fw.model.lookup.AbstractCode;
import gov.va.med.fw.model.lookup.Lookup;

public class VOASearchType extends UIAbstractLookup
{
    private static final long serialVersionUID = 4578846161156280591L;

    public static final Code CODE_ALL_PENDING_SUBMISSIONS = new Code("1");
    public static final Code CODE_SUBMISSION_ID = new Code("2");
    public static final Code CODE_FORM_TYPE = new Code("3");
    public static final Code CODE_REQUEST_RECEIVED_DATE = new Code("4");
    public static final Code CODE_FORM_PENDING_REASON = new Code("5");

    private static Map map;

    static
    {
        map = new HashMap();
        map.put("1", new VOASearchType("1", "All Pending Submissions"));
        map.put("2", new VOASearchType("2", "Submission ID"));
        map.put("3", new VOASearchType("3", "Form Type"));
        map.put("4", new VOASearchType("4", "Request Received Date"));
        map.put("5", new VOASearchType("5", "Form Pending Reason"));
    }

    private VOASearchType(String code, String description)
    {
        super(code, description);
    }

    public static List findAll()
    {
        return new ArrayList(map.values());
    }

    public static Lookup getByCode(String code)
    {
        return (Lookup)map.get(code);
    }

    public static class Code extends AbstractCode
    {

        private static final long serialVersionUID = -2301533895300043106L;

        private Code(String code)
        {
            super(code);
        }

        public static Code getByCode(String code)
        {
            return (Code)getCode(Code.class, code);
        }
    }
}
