/********************************************************************
 * Copyright  2005 VHA. All rights reserved
 ********************************************************************/
package gov.va.med.esr.ui.comms.action;

// Java Classes

// Library Classes

// Framework Classes

// ESR Classes
import gov.va.med.esr.ui.common.action.AddressForm;

/**
 * This is the form used in conjunction with the Undeliverable Mail Search page.
 *
 * @author Andrew Pach
 * @version 3.0
 */
public class UndeliverableMailSearchForm extends AddressForm
{
    private static final long serialVersionUID = 4344735761500360402L;
    
    private String SSN = null;
    private String barcode = null;
    private String givenName = null;
    private String middleName = null;
    private String familyName = null;
    private String formNumber = null;
    private String caseNumber = null;
    private String dateMailed = null;

    /**
     * Default constructor.
     */
    public UndeliverableMailSearchForm()
    {
        super();
    }

    /**
     * Initializes the data on this form.
     */
    protected void clear()
    {
        initialize();
        SSN = null;
        barcode = null;
        givenName = null;
        middleName = null;
        familyName = null;
        formNumber = null;
        caseNumber = null;
        dateMailed = null;
    }

    public String getSSN()
    {
        return SSN;
    }

    public void setSSN(String SSN)
    {
        this.SSN = SSN;
    }

    public String getBarcode()
    {
        return barcode;
    }

    public void setBarcode(String barcode)
    {
        this.barcode = barcode;
    }

    public String getGivenName()
    {
        return givenName;
    }

    public void setGivenName(String givenName)
    {
        this.givenName = givenName;
    }

    public String getMiddleName()
    {
        return middleName;
    }

    public void setMiddleName(String middleName)
    {
        this.middleName = middleName;
    }

    public String getFamilyName()
    {
        return familyName;
    }

    public void setFamilyName(String familyName)
    {
        this.familyName = familyName;
    }

    public String getFormNumber()
    {
        return formNumber;
    }

    public void setFormNumber(String formNumber)
    {
        this.formNumber = formNumber;
    }

    public String getCaseNumber()
    {
        return caseNumber;
    }

    public void setCaseNumber(String caseNumber)
    {
        this.caseNumber = caseNumber;
    }

    public String getDateMailed()
    {
        return dateMailed;
    }

    public void setDateMailed(String dateMailed)
    {
        this.dateMailed = dateMailed;
    }
}
