<%@ page contentType="text/html;charset=UTF-8"%>
<%@ taglib uri="/tags/struts-bean" prefix="bean"%>
<%@ taglib uri="/tags/struts-html" prefix="html"%>
<%@ taglib uri="/tags/struts-bean-el" prefix="bean-el"%>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html-el"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ taglib uri="/tags/struts-logic" prefix="logic"%>
<%@ taglib uri="/tags/displaytag" prefix="display"%>
<%@ taglib uri="/tags/esr-core" prefix="esrcore"%>
<%@ taglib uri="/tags/fw" prefix="fw"%>
<%@ taglib uri="/tags/valuelist" prefix="vlh"%>
<%@ taglib uri="/tags/authz" prefix="auth"%>
<%@ page import='gov.va.med.esr.common.model.lookup.Capability'%>

<table width="100%" border="0" cellpadding="0" cellspacing="0" role="presentation">
	<tr valign="top">
		<td width="50%">
		<table width="100%" border="0" cellpadding="0" cellspacing="0" role="presentation">
			<!-- Eligibility Table -->
			<c:set var="viewEligibilityCode">
				<%=Capability.VIEW_ELIGIBILITY_ENROLLMENT.getName()%>
			</c:set>
			<c:set var="editEligibilityCode">
				<%=Capability.EDIT_ELIGIBILITY.getName()%>
			</c:set>
			<c:set var="viewEligibility" value="false" />
			<c:set var="editEligibility" value="false" />
			<auth:authorize ifAnyGranted="${editEligibilityCode}">
				<c:set var="editEligibility" value="true" />
			</auth:authorize>
			<auth:authorize
				ifAnyGranted="${editEligibilityCode},${viewEligibilityCode}">
				<c:set var="viewEligibility" value="true" />
			</auth:authorize>

			<%-- Person Locked Check --%>
			<c:set var="appData" value="${AppData}" scope="session" />
			<c:set var="personKey" value="SelectedPerson" />
			<c:set var="personLocked" value="${appData[personKey].personLocked}" />
			<c:if test="${personLocked}">
				<c:set var="editEligibility" value="false" />
			</c:if>

			<tr>
				<td>
				<table width="100%" border="0" cellpadding="0" cellspacing="0"
					class="moduleShell" role="presentation">
					<tr>
						<td>
						<table width="100%" border="0" cellpadding="0" cellspacing="0"
							class="moduleShellTable" role="presentation">
							<tr>
								<td>
								<table width="100%" border="0" cellpadding="0" cellspacing="0"
									class="moduleShellTableHead" role="presentation">
									<tr>
										<td class="moduleBlueBox"><img alt=""
											src="../images/spacer.gif" width="25" height="17" /></td>
										<td nowrap class="moduleHeadline"><c:choose>
											<c:when test="${editEligibility == true}">
												<fw:link action="/gotoEligibilityEdit.do?methodName=Edit"
													module="/ee">
													<bean:message key="label.link.updateCurrentEligibility" />
												</fw:link>
											</c:when>
											<c:otherwise>
												<bean:message key="label.link.updateCurrentEligibility" />
											</c:otherwise>
										</c:choose></td>
										<td width="100%"><img alt="" src="../images/spacer.gif"></td>
										<c:if test="${viewEligibility == true}">
											<td nowrap class="moduleBlueLink" style="padding: 1 8 1 8">
											<fw:link action="/eligibilityView.display.do" module="/ee">
												<bean:message key="label.link.eligibility" />
											</fw:link></td>
										</c:if>
									</tr>
								</table>
								</td>
							</tr>

							<tr>
								<td>
								<table width="100%" border="0" cellspacing="0" cellpadding="0"
									class="moduleShellTableBody" role="presentation">
									<tr>
										<td width="50%" class="label"><bean:message
											key="label.primaryEligibilityCode" />:</td>
										<td width="50%" class="value"><esrcore:displayValue
											name="overviewForm" property="primaryEligibilityCode" /></td>
									</tr>
									<tr valign="top">
										<td class="darklabel"><bean:message
											key="label.secondaryEligibilityCodes" />:</td>
										<td class="darkvalue"><esrcore:displayValue
											name="overviewForm"
											property="formattedSecondaryEligibilityCodes" /></td>
									</tr>
									<tr>
										<td class="label"><bean:message
											key="label.serviceConnectedPercentage" />:</td>
										<td class="value"><esrcore:displayValue
											name="overviewForm" property="serviceConnectedPercentage" /></td>
									</tr>
									<tr>
										<td class="darklabel"><bean:message
											key="label.eligibilityStatus" />:</td>
										<td class="darkvalue"><esrcore:displayValue
											name="overviewForm" property="eligibilityStatus.description" /></td>
									</tr>
									<tr valign="top">
										<td class="label"><bean:message
											key="label.currentNumberHealthBenefitPlans" />:</td>
										<td class="value"><esrcore:displayValue
											name="overviewForm" property="currentNumberOfHealthBenefitPlans" /></td>
									</tr>
								</table>
								</td>
							</tr>
						</table>
						</td>
					</tr>
				</table>
				</td>
			</tr>

			<tr height="10">
				<td></td>
			</tr>
			<!-- row spacing -->

			<!-- Mailing Address - Demographics -->
			<c:set var="updateAddress" value="false" />
			<c:set var="viewDemographics" value="false" />
			<auth:authorize ifAnyGranted="<%=Capability.UPDATE_ADDRESS%>">
				<c:set var="updateAddress" value="true" />
			</auth:authorize>
			<auth:authorize ifAnyGranted="<%=Capability.DEMOGRAPHICS%>">
				<c:set var="viewDemographics" value="true" />
			</auth:authorize>

			<tr>
				<td>
				<table width="100%" border="0" cellpadding="0" cellspacing="0"
					class="moduleShell" role="presentation">
					<tr>
						<td>
						<table width="100%" border="0" cellpadding="0" cellspacing="0"
							class="moduleShellTable" role="presentation">
							<tr>
								<td>
								<table width="100%" border="0" cellpadding="0" cellspacing="0"
									class="moduleShellTableHead" role="presentation">
									<tr>
										<td class="moduleBlueBox"><img alt=""
											src="../images/spacer.gif" width="25" height="17" /></td>
										<td nowrap class="moduleHeadline"><c:choose>
											<c:when test="${updateAddress == true}">
												<fw:link
													action="/demographicAddresses.do?methodName=Addresses"
													module="/demographic">
													<bean:message key="label.link.updateMailingAddress" />
												</fw:link>
											</c:when>
											<c:otherwise>
												<bean:message key="label.link.updateMailingAddress" />
											</c:otherwise>
										</c:choose></td>
										<td width="100%"><img alt="" src="../images/spacer.gif"></td>
										<td nowrap class="moduleBlueLink" style="padding: 1 8 1 8">
										<c:if test="${viewDemographics == true}">
											<fw:link action="/demographicOverview.do?methodName=Overview"
												module="/demographic">
												<bean:message key="label.link.demographics" />
											</fw:link>
										</c:if></td>
									</tr>
								</table>
								</td>
							</tr>

							<tr>
								<td>
								<table width="100%" border="0" cellspacing="0" cellpadding="0"
									class="moduleShellTableBody" role="presentation">
									<c:choose>
										<c:when
											test="${overviewForm.currentMailingAddress != null || overviewForm.phoneNumber != null}">
											<c:if test="${overviewForm.badAddressReason != null}">
												<tr valign="top">
													<td width="50%" style="color: red" class="darklabel"><bean:message
														key="label.addresses.badAddressReason" />:</td>
													<td class="darkvalue"><esrcore:displayValue
														name="overviewForm" property="badAddressReason" /></td>
												</tr>
											</c:if>
											<tr valign="top">
												<td width="50%" class="label"><bean:message
													key="label.address" />:</td>
												<td class="value"><esrcore:displayValue
													name="overviewForm" property="currentMailingAddress" /></td>
											</tr>
											<tr>
												<td width="50%" class="darklabel"><bean:message
													key="label.homePhone" />:</td>
												<td class="darkvalue"><esrcore:displayValue
													name="overviewForm" property="phoneNumber" /></td>
											</tr>
										</c:when>
										<c:otherwise>
											<tr>
												<td class="value" style="text-align: center"><bean:message
													key="text.nodata" /></td>
											<tr>
										</c:otherwise>
									</c:choose>
								</table>
								</td>
							</tr>
						</table>
						</td>
					</tr>
				</table>
				</td>
			</tr>

			<tr height="10">
				<td></td>
			</tr>
			<!-- row spacing -->

			<!-- Signature -->
			<c:set var="viewSignatureCode">
				<%=Capability.VIEW_SIGNATURE_INFO.getName()%>
			</c:set>
			<c:set var="editSignatureCode">
				<%=Capability.EDIT_SIGNATURE_INFO.getName()%>
			</c:set>
			<c:set var="viewSignature" value="false" />
			<c:set var="editSignature" value="false" />
			<auth:authorize
				ifAnyGranted="${viewSignatureCode},${editSignatureCode}">
				<c:set var="viewSignature" value="true" />
			</auth:authorize>
			<auth:authorize ifAnyGranted="${editSignatureCode}">
				<c:set var="editSignature" value="true" />
			</auth:authorize>
			<tr>
				<td>
				<table width="100%" border="0" cellpadding="0" cellspacing="0"
					class="moduleShell" role="presentation">
					<tr>
						<td>
						<table width="100%" border="0" cellpadding="0" cellspacing="0"
							class="moduleShellTable" role="presentation">
							<tr>
								<td>
								<table width="100%" border="0" cellpadding="0" cellspacing="0"
									class="moduleShellTableHead" role="presentation">
									<tr>
										<td class="moduleBlueBox"><img alt=""
											src="../images/spacer.gif" width="25" height="17" /></td>
										<td nowrap class="moduleHeadline"><c:choose>
											<c:when test="${editSignature == true}">
												<fw:link action="/signatureView.display.do"
													module="/signature">
													<bean:message key="label.link.updateSignature" />
												</fw:link>
											</c:when>
											<c:otherwise>
												<bean:message key="label.link.updateSignature" />
											</c:otherwise>
										</c:choose></td>
										<td width="100%"><img alt="" src="../images/spacer.gif"></td>
										<td nowrap class="moduleBlueLink" style="padding: 1 8 1 8">
										<c:if test="${viewSignature == true}">
											<fw:link action="/signatureView.display.do"
												module="/signature">
												<bean:message key="label.link.signatureView" />
											</fw:link>
										</c:if></td>
									</tr>
								</table>
								</td>
							</tr>

							<tr>
								<td>
								<table width="100%" border="0" cellspacing="0" cellpadding="0"
									class="moduleShellTableBody" role="presentation">
									<c:choose>
										<c:when test="${overviewForm.dateIndexed != null}">
											<tr valign="top">
												<td width="50%" class="label"><bean:message
													key="label.signatureOnFile" />:</td>
												<td class="value"><esrcore:displayValue
													name="overviewForm" property="signatureOnFile" /></td>
											</tr>
											<tr>
												<td width="50%" class="darklabel"><bean:message
													key="label.imageId" />:</td>
												<td class="darkvalue"><esrcore:displayValue
													name="overviewForm" property="imageId" /></td>
											</tr>
											<tr>
												<td width="50%" class="label"><bean:message
													key="label.dateIndexed" />:</td>
												<td class="value"><esrcore:displayDate
													name="overviewForm" dateProperty="dateIndexed"
													displayTime="false" nullText="" /></td>
											</tr>
										</c:when>
										<c:otherwise>
											<tr>
												<td class="value" style="text-align: center"><bean:message
													key="text.nodata" /></td>
											<tr>
										</c:otherwise>
									</c:choose>
								</table>
								</td>
							</tr>
						</table>
						</td>
					</tr>
				</table>
				</td>
			</tr>
         
         <!-- VHIC Card -- no permission check necessary since all ESC user can view VHIC-->
          <tr height="10">
                <td></td>
           </tr>
            <tr>
                <td>
                <table width="100%" border="0" cellpadding="0" cellspacing="0"
                    class="moduleShell" role="presentation">
                    <tr>
                        <td>
                        <table width="100%" border="0" cellpadding="0" cellspacing="0"
                            class="moduleShellTable" role="presentation">
                            <tr>
                                <td>
                                <table width="100%" border="0" cellpadding="0" cellspacing="0"
                                    class="moduleShellTableHead" role="presentation">
                                    <tr>
                                        <td class="moduleBlueBox"><img alt=""
                                            src="../images/spacer.gif" width="25" height="17" /></td>
                                        <td nowrap class="moduleHeadline"> 
                                             <fw:link action="/commslog.do?methodName=VHIC Status"
                                                    module="/comms">
                                                    <bean:message key="label.link.viewVhicCard" />
                                                </fw:link>
                                         </td>
                                            <td width="100%"><img alt="" src="../images/spacer.gif"></td>
                                                <td nowrap class="moduleBlueLink" style="padding: 1 8 1 8">
                                                <fw:link action="/commslog.do?methodName=VHIC Status"
                                                    module="/comms">
                                                    <bean:message key="label.link.Communications" />
                                                </fw:link></td>
                                       </tr>
                                </table>
                                </td>
                            </tr>

                            <tr>
                                <td>
                                <table width="100%" border="0" cellspacing="0" cellpadding="0"
                                    class="moduleShellTableBody" role="presentation">
                                   <tr valign="top">
                                                <td width="50%" class="label"><bean:message
                                                    key="label.vhicCardNumber" />:</td>
                                                <td class="value"><esrcore:displayValue
                                                    name="overviewForm" property="vhicCardNum" /></td>
                                            </tr>
                                            <tr>
                                                <td width="50%" class="darklabel"><bean:message
                                                    key="label.vhicCardStatus" />:</td>
                                                <td class="darkvalue"><esrcore:displayValue
                                                    name="overviewForm" property="vhicCardStatus" /></td>
                                            </tr>
                                       
                                </table>
                                </td>
                            </tr>
                        </table>
                        </td>
                    </tr>
                </table>
                </td>
            </tr>
		</table>
		<!-- End left column of tables --></td>

		<!-- Column spacer between left and right set of tables. -->
		<td><img alt="" src="../images/spacer.gif" width="10" height="1" /></td>

		<td width="50%">
		<table width="100%" border="0" cellpadding="0" cellspacing="0" role="presentation">
			<!-- Financials -->
			<c:set var="updateFinancials" value="false" />
			<c:set var="viewFinancials" value="false" />
			<c:set var="addIncomeTestCode">
				<%=Capability.ADD_INCOME_TEST.getName()%>
			</c:set>
			<c:set var="editIncomeTestCode">
				<%=Capability.EDIT_INCOME_TEST.getName()%>
			</c:set>
			<c:set var="viewFinancialsCodes">
				<%=Capability.FINANCIALS%>
			</c:set>
			<auth:authorize
				ifAnyGranted="${addIncomeTestCode},${editIncomeTestCode}">
				<c:set var="updateFinancials" value="true" />
			</auth:authorize>
			<auth:authorize ifAnyGranted="${viewFinancialsCodes}">
				<c:set var="viewFinancials" value="true" />
			</auth:authorize>

			<tr>
				<td>
				<table width="100%" border="0" cellpadding="0" cellspacing="0"
					class="moduleShell" role="presentation">
					<tr>
						<td>
						<table width="100%" border="0" cellpadding="0" cellspacing="0"
							class="moduleShellTable" role="presentation">
							<tr>
								<td>
								<table width="100%" border="0" cellpadding="0" cellspacing="0"
									class="moduleShellTableHead" role="presentation">
									<tr>
										<td class="moduleBlueBox"><img alt=""
											src="../images/spacer.gif" width="25" height="17" /></td>
										<td nowrap class="moduleHeadline"><c:choose>
											<c:when test="${updateFinancials == true}">
												<fw:link
													action="/financialsOverview.do?methodName=Financials"
													module="/financials">
													<bean:message key="label.link.updateFinancialAssesment" />
												</fw:link>
											</c:when>
											<c:otherwise>
												<bean:message key="label.link.updateFinancialAssesment" />
											</c:otherwise>
										</c:choose></td>
										<td width="100%"><img alt="" src="../images/spacer.gif"></td>
										<td nowrap class="moduleBlueLink" style="padding: 1 8 1 8">
										<c:if test="${viewFinancials == true}">
											<fw:link
												action="/financialsOverview.do?methodName=Financials"
												module="/financials">
												<bean:message key="label.link.financials" />
											</fw:link>
										</c:if></td>
									</tr>
								</table>
								</td>
							</tr>

							<tr>
								<td>
								<table width="100%" border="0" cellspacing="0" cellpadding="0"
									class="moduleShellTableBody" role="presentation">
									<c:choose>
										<c:when test="${overviewForm.currentTestType == null}">
											<tr>
												<td class="value" style="text-align: center"><bean:message
													key="label.noCurrentIncomeTestDataAvailable" /></td>
											<tr>
										</c:when>
										<c:when
											test="${overviewForm.primaryTestType != null || overviewForm.meansTestStatus != null || overviewForm.pharmacyCoPayStatus != null}">
											<tr>
												<td width="50%" class="label"><bean:message
													key="label.primaryTestType" />:</td>
												<td width="50%" class="value"><esrcore:displayValue
													name="overviewForm" property="primaryTestType" /></td>
											</tr>
											<tr>
												<td class="darklabel"><bean:message
													key="label.meansTestStatus" />:</td>
												<td class="darkvalue"><esrcore:displayValue
													name="overviewForm" property="meansTestStatus" /></td>
											</tr>
											<tr>
												<td class="label"><bean:message
													key="label.pharmacyCoPayStatus" />:</td>
												<td class="value"><esrcore:displayValue
													name="overviewForm" property="pharmacyCoPayStatus" /></td>
											</tr>
										</c:when>
										<c:when
											test="${overviewForm.ltcCoPayStatus != null || overviewForm.ltcCoPayExemptionStatus != null}">
											<tr>
												<td class="value" style="text-align: center"><bean:message
													key="label.onlyLongTermCareAvailable" /></td>
											<tr>
										</c:when>
										<c:otherwise>
											<tr>
												<td class="value" style="text-align: center"><bean:message
													key="label.noCurrentIncomeTestDataAvailable" /></td>
											<tr>
										</c:otherwise>
									</c:choose>
								</table>
								</td>
							</tr>
						</table>
						</td>
					</tr>
				</table>
				</td>
			</tr>

			<tr height="10">
				<td></td>
			</tr>
			<!-- row spacing -->

			<!-- Enrollment -->
			<c:set var="viewEnrollmentCode">
				<%=Capability.VIEW_ELIGIBILITY_ENROLLMENT.getName()%>
			</c:set>
			<c:set var="editAppDateCode">
				<%=Capability.EDIT_ENROLLMENT_APP_DATE.getName()%>
			</c:set>
			<c:set var="editOverrideCode">
				<%=Capability.EDIT_ENROLLMENT_OVERRIDE.getName()%>
			</c:set>
			<c:set var="editCancelDeclineCode">
				<%=Capability.EDIT_CANCEL_DECLINE_ENROLLMENT.getName()%>
			</c:set>
			<c:set var="viewEnrollment" value="false" />
			<c:set var="editEnrollment" value="false" />
			<auth:authorize
				ifAnyGranted="${editAppDateCode},${editOverrideCode},${editCancelDeclineCode}">
				<c:set var="editEnrollment" value="true" />
				<c:set var="viewEnrollment" value="true" />
			</auth:authorize>
			<auth:authorize ifAnyGranted="${viewEnrollmentCode}">
				<c:set var="viewEnrollment" value="true" />
			</auth:authorize>

			<tr>
				<td>
				<table width="100%" border="0" cellpadding="0" cellspacing="0"
					class="moduleShell" role="presentation">
					<tr>
						<td>
						<table width="100%" border="0" cellpadding="0" cellspacing="0"
							class="moduleShellTable" role="presentation">
							<tr>
								<td>
								<table width="100%" border="0" cellpadding="0" cellspacing="0"
									class="moduleShellTableHead" role="presentation">
									<tr>
										<td class="moduleBlueBox"><img alt=""
											src="../images/spacer.gif" width="25" height="17" /></td>
										<td nowrap class="moduleHeadline"><c:choose>
											<c:when test="${editEnrollment == true}">
												<fw:link action="/enrollment.do?methodName=DISPLAY"
													module="/ee">
													<bean:message key="label.link.updateEnrollmentDates" />
												</fw:link>
											</c:when>
											<c:otherwise>
												<bean:message key="label.link.updateEnrollmentDates" />
											</c:otherwise>
										</c:choose></td>
										<td width="100%"><img alt="" src="../images/spacer.gif"></td>
										<td nowrap class="moduleBlueLink" style="padding: 1 8 1 8">
										<c:if test="${viewEnrollment == true}">
											<fw:link action="/enrollment.do?methodName=DISPLAY"
												module="/ee">
												<bean:message key="label.link.enrollment" />
											</fw:link>
										</c:if></td>
									</tr>
								</table>
								</td>
							</tr>

							<tr>
								<td>
								<table width="100%" border="0" cellspacing="0" cellpadding="0"
									class="moduleShellTableBody" role="presentation">
									<c:choose>
										<c:when
											test="${overviewForm.applicationDate != null || overviewForm.effectiveDateOfChange != null}">
											<tr>
												<td width="50%" class="label"><bean:message
													key="label.applicationDate" />:</td>
												<td width="50%" class="value"><esrcore:displayValue
													name="overviewForm" property="applicationDate" /></td>
											</tr>
											<tr>
												<td class="darklabel"><bean:message
													key="label.effectiveDateOfChange" />:</td>
												<td class="darkvalue"><esrcore:displayValue
													name="overviewForm" property="effectiveDateOfChange" /></td>
											</tr>
										</c:when>
										<c:otherwise>
											<tr>
												<td class="value" style="text-align: center"><bean:message
													key="text.nodata" /></td>
											<tr>
										</c:otherwise>
									</c:choose>
								</table>
								</td>
							</tr>
						</table>
						</td>
					</tr>
				</table>
				</td>
			</tr>

			<tr height="10">
				<td></td>
			</tr>
			<!-- row spacing -->

			<!-- Update Date of Death - Demographics -->
			<c:set var="updateDemographics" value="false" />
			<auth:authorize
				ifAnyGranted="<%=Capability.EDIT_DEMOGRAPHIC_INFO.getName()%>">
				<c:set var="updateDemographics" value="true" />
			</auth:authorize>

			<tr>
				<td>
				<table width="100%" border="0" cellpadding="0" cellspacing="0"
					class="moduleShell" role="presentation">
					<tr>
						<td>
						<table width="100%" border="0" cellpadding="0" cellspacing="0"
							class="moduleShellTable" role="presentation">
							<tr>
								<td>
								<table width="100%" border="0" cellpadding="0" cellspacing="0"
									class="moduleShellTableHead" role="presentation">
									<tr>
										<td class="moduleBlueBox"><img alt=""
											src="../images/spacer.gif" width="25" height="17" /></td>
										<td nowrap class="moduleHeadline"><c:choose>
											<c:when test="${updateDemographics == true}">
												<fw:link
													action="/demographicPersonal.do?methodName=Personal"
													module="/demographic">
													<bean:message key="label.link.updateDateOfDeath" />
												</fw:link>
											</c:when>
											<c:otherwise>
												<bean:message key="label.link.updateDateOfDeath" />
											</c:otherwise>
										</c:choose></td>
										<td width="100%"><img alt="" src="../images/spacer.gif"></td>
										<td nowrap class="moduleBlueLink" style="padding: 1 8 1 8">
										<c:if test="${viewDemographics == true}">
											<fw:link action="/demographicOverview.do?methodName=Overview"
												module="/demographic">
												<bean:message key="label.link.demographics" />
											</fw:link>
										</c:if></td>
									</tr>
								</table>
								</td>
							</tr>

							<tr>
								<td>
								<table width="100%" border="0" cellspacing="0" cellpadding="0"
									class="moduleShellTableBody" role="presentation">
									<tr>
										<td width="50%" class="label"><bean:message
											key="label.currentStatus" />:</td>
										<td width="50%" class="value"><esrcore:displayValue
											name="overviewForm" property="currentStatus" /></td>
									</tr>
								</table>
								</td>
							</tr>
						</table>
						</td>
					</tr>
				</table>
				</td>
			</tr>

			<tr height="10">
				<td></td>
			</tr>
			<!-- row spacing -->

			<auth:authorize
				ifAnyGranted="<%=Capability.VIEW_HANDBOOK.getName()%>">
				<c:set var="viewHandbook" value="true" />
			</auth:authorize>
			<auth:authorize
				ifAnyGranted="<%=Capability.VIEW_BENEFITS_AT_A_GLANCE.getName()%>">
				<c:set var="viewAtAGlance" value="true" />
			</auth:authorize>

			<!-- if the user can view neither the HANDBOOK nor the AT A GLANCE doc then do not display this area -->
			<c:choose>
				<c:when test="${viewHandbook == true || viewAtAGlance == true}">
					<tr>
						<td>
						<table width="100%" border="0" cellpadding="0" cellspacing="0"
							class="moduleShell" role="presentation">
							<tr>
								<td>
								<table width="100%" border="0" cellpadding="0" cellspacing="0"
									class="moduleShellTable" role="presentation">
									<tr>
										<td>
										<table width="100%" border="0" cellpadding="0" cellspacing="0"
											class="moduleShellTableHead" role="presentation">
											<tr>
												<td class="moduleBlueBox"><img alt=""
													src="../images/spacer.gif" width="25" height="17" /></td>
												<td nowrap class="moduleHeadline"><fw:link
													action="/commslog.do?methodName=Handbook Status"
													module="/comms">
													<bean:message key="label.link.viewHandBook" />
												</fw:link></td>
												<td width="100%"><img alt="" src="../images/spacer.gif"></td>
												<td nowrap class="moduleBlueLink" style="padding: 1 8 1 8">
												<fw:link action="/commslog.do?methodName=Handbook Status"
													module="/comms">
													<bean:message key="label.link.Communications" />
												</fw:link></td>
											</tr>
										</table>
										</td>
									</tr>

									<tr>
										<td>
										<table summary="Overview of Hand Book Communications" width="100%" border="0" cellspacing="0" cellpadding="0"
											class="moduleShellTableBody" role="presentation">

											<c:choose>
												<c:when test="${overviewForm.handbookInfo == true}">

													<th scope="col" width=60%>Communication to View</th>
													<th scope="col" width=25%>Date</th>
													<th scope="col" width=15%>Source</th>

													<c:if test="${viewHandbook == true }">
														<vlh:root id="handbookTableId" value="vlhlist" url="?"
															includeParameters="*"
															configName="valueListConfigBeanLookAndFeel">
															<c:set var="viewCount" value="0" />
															<vlh:row bean="handbookInfo">
																<c:set var="viewCount" value="${viewCount + 1}" />
																<c:choose>
																	<c:when test="${viewCount == 1}">
																		<vlh:column>
																		<vlh:attribute name="scope">row</vlh:attribute>
																			<fw:link
																				action="/commsHandbook.do?methodName=Handbook&fileId=${handbookInfo.fileId}"
																				module="/comms" target="_blank">
														                 Veterans Current Handbook
											                           </fw:link>

																		</vlh:column>
																	</c:when>
																	<c:otherwise>
																		<vlh:column>
																		<vlh:attribute name="scope">row</vlh:attribute>
																			<fw:link
																				action="/commsHandbook.do?methodName=Handbook&fileId=${handbookInfo.fileId}"
																				module="/comms" target="_blank">
														                  Veterans Handbook
											                             </fw:link>

																		</vlh:column>
																	</c:otherwise>
																</c:choose>

																<vlh:column>
																	<esrcore:displayValue name="handbookInfo"
																		property="generatedDate" nullText="" />
																</vlh:column>

																<vlh:column>
																	<esrcore:displayValue name="handbookInfo"
																		property="source" nullText="" />
																</vlh:column>

															</vlh:row>
														</vlh:root>
													</c:if>

													<c:if test="${viewAtAGlance == true }">
														<vlh:root id="benefitsTableId" value="vhlbenefit" url="?"
															includeParameters="*"
															configName="valueListConfigBeanLookAndFeel">
															<c:set var="viewCount" value="0" />
															<vlh:row bean="benefitsInfo">
																<c:set var="viewCount" value="${viewCount + 1}" />
																<c:choose>
																	<c:when test="${viewCount == 1}">
																		<vlh:column>
																		<vlh:attribute name="scope">row</vlh:attribute>
																			<fw:link
																				action="/commsHandbook.do?methodName=BenefitGlance&fileId=${benefitsInfo.fileId}"
																				module="/comms" target="_blank">
														                 Veterans Current Benefits at a Glance
											                           </fw:link>

																		</vlh:column>
																	</c:when>
																	<c:otherwise>
																		<vlh:column>
																		<vlh:attribute name="scope">row</vlh:attribute>
																			<fw:link
																				action="/commsHandbook.do?methodName=BenefitGlance&fileId=${benefitsInfo.fileId}"
																				module="/comms" target="_blank">
																			Veterans Benefits at a Glance
                                                                            </fw:link>

																		</vlh:column>
																	</c:otherwise>
																</c:choose>

																<vlh:column>
																	<esrcore:displayValue name="benefitsInfo"
																		property="generatedDate" nullText="" />
																</vlh:column>

																<vlh:column>
																	<esrcore:displayValue name="benefitsInfo"
																		property="source" nullText="" />
																</vlh:column>
															</vlh:row>
														</vlh:root>
													</c:if>
												</c:when>
												<c:otherwise>
													<tr>
														<td class="value" style="text-align: center"><bean:message
															key="text.nodata" /></td>
													<tr>
												</c:otherwise>
											</c:choose>

										</table>
										</td>
									</tr>
								</table>
								</td>
							</tr>
						</table>
						</td>
					</tr>
				</c:when>

			</c:choose>


		</table>
		<!-- End right column of tables --></td>
	</tr>
</table>
