<%@ taglib uri="/tags/struts-bean-el" prefix="bean-el" %>
<%@ taglib uri="http://struts.apache.org/tags-html" prefix="html-el" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ taglib uri="/tags/fw" prefix="fw" %> 
<%@ taglib uri="/tags/esr-core" prefix="esrcore" %>

<c:set var="IndicatorNO"><%=gov.va.med.esr.common.model.lookup.Indicator.NO.getCode()%></c:set>
<c:set var="IndicatorYES"><%=gov.va.med.esr.common.model.lookup.Indicator.YES.getCode()%></c:set>
<c:set var="expandableSectionCollapsed" scope="page"><bean-el:message key="label.expandableSectionCollapsed"/></c:set>

<esrcore:setLookup var="SortedIndicator" className="gov.va.med.esr.ui.common.beans.SortedIndicator" />

<table width="100%" border="0" cellspacing="0" cellpadding="0" class="moduleShellTableBody" role="presentation">
<tr>
    <td colspan="2">
      <%@ include file="/tiles/common/instructionalText.jsp" %>
    </td>
</tr>
<tr>
	<td width="50%" class="moduleLabel"><bean-el:message key="label.dischargeDueToDisablility" />:</td>
	<td width="50%" class="moduleValue">
	       <c:set var="dischargeDueToDisabilityLabel"><bean-el:message key="label.dischargeDueToDisablility"/></c:set>
		<c:forEach var="item" items="${SortedIndicator}">
			<html-el:radio title="${dischargeDueToDisabilityLabel} (${item.description})" property="dischargeDueToDisability" styleId="idDischargeDueToDisability_${item.code}" value="${item.code}" disabled="${readOnlyMS}"/>
			<fw:label property="dischargeDueToDisability" forId="idDischargeDueToDisability_${item.code}"><c:out value="${item.description}" />&nbsp;&nbsp;</fw:label>
		</c:forEach>
	</td>
</tr>
<tr>
	<td class="moduleLabel"><bean-el:message key="label.militaryDisabilityRetirement" />:</td>
	<td class="moduleValue">
	        <c:set var="retirementDueToMilitaryDisabilityLabel"><bean-el:message key="label.militaryDisabilityRetirement"/></c:set>
		<c:forEach var="item" items="${SortedIndicator}">
			<html-el:radio title="${retirementDueToMilitaryDisabilityLabel} (${item.description})" property="retirementDueToMilitaryDisability" styleId="idRetirementDueToMilitaryDisability_${item.code}" value="${item.code}" disabled="${readOnlyMS}"/>
			<fw:label property="retirementDueToMilitaryDisability" forId="idRetirementDueToMilitaryDisability_${item.code}"><c:out value="${item.description}" />&nbsp;&nbsp;</fw:label>
		</c:forEach>
	</td>
</tr>
<tr>
	<td class="moduleLabel"><fw:label property="agentOrangeExposureLocation" forId="idAgentOrangeExposureLocation"><bean-el:message key="label.agentOrangeLocation" />:</fw:label></td>
	<td class="moduleValue">
		<c:set var="agentOrangeExposureLocationLabel"><bean-el:message key="label.agentOrangeLocation"/></c:set>
		<c:set var="agentOrangeLocationRemovedWarning"><bean-el:message key="message.agentOrangeLocationRemoved" /></c:set>
        <table border="0" cellpadding="0" cellspacing="0" class="moduleShellLowTableBody" role="presentation">
            <tr>
                <td>
            		<html-el:select title="${agentOrangeExposureLocationLabel}" styleClass="moduleEdit" styleId="idAgentOrangeExposureLocation" property="agentOrangeExposureLocation" disabled="${readOnlyMS}"> 
            			<html-el:option styleClass="moduleEdit" value=""><bean-el:message key="label.notExposed" /></html-el:option>
            			<esrcore:options styleClass="moduleEdit" collection="gov.va.med.esr.common.model.lookup.AgentOrangeExposureLocation" property="code" labelProperty="description"/> 
            		</html-el:select>
                </td>
                <td>
                    &nbsp;
                </td>
                <td>
                    <table width="10%" border="0" cellpadding="0" cellspacing="0" class="moduleShellLowTableBody" role="presentation">
                        <tr>
                            <td><img alt=""  src="../images/buttonEndLeft.gif"  border="0"/></td>
                            <td><html-el:submit property="methodName" style="width:50; vertical-align: top;" styleClass="buttonText"  onclick="displayMessageIfFieldEmpty(idAgentOrangeExposureLocation,'${agentOrangeLocationRemovedWarning}'); return false;"><bean-el:message key="button.apply"/></html-el:submit></td>
                            <td><img alt=""  src="../images/buttonEndRight.gif" border="0"/></td>
                        </tr>
                    </table>
                </td>
            </tr>
        </table>
	</td>
</tr>
<tr>
	<td class="moduleLabel"><fw:label property="radiationExposureMethod" forId="idRadiationExposureMethod"><bean-el:message key="label.radiationExposureMethod" />:</fw:label></td>
	<td class="moduleValue">
        <c:set var="radiationExposureMethodLabel"><bean-el:message key="label.radiationExposureMethod"/></c:set>
		<c:set var="radiationExposureMethodRemovedWarning"><bean-el:message key="message.radiationExposureMethodRemoved" /></c:set>
        <table border="0" cellpadding="0" cellspacing="0" class="moduleShellLowTableBody" role="presentation">
            <tr>
                <td>
            		<html-el:select title="${radiationExposureMethodLabel}" styleClass="moduleEdit" property="radiationExposureMethod" styleId="idRadiationExposureMethod" disabled="${readOnlyMS}">
            			<html-el:option styleClass="moduleEdit" value=""><bean-el:message key="label.notExposed" /></html-el:option>
            			<esrcore:options styleClass="moduleEdit" collection="gov.va.med.esr.common.model.lookup.RadiationExposureMethod" property="code" labelProperty="description"/> 
            		</html-el:select>
                </td>
                <td>
                    &nbsp;
                </td>
                <td>
                    <table width="10%" border="0" cellpadding="0" cellspacing="0" class="moduleShellLowTableBody" role="presentation">
                        <tr>
                            <td><img alt=""  src="../images/buttonEndLeft.gif"  border="0"/></td>
                            <td><html-el:submit property="methodName" style="width:50; vertical-align: top;" styleClass="buttonText"  onclick="displayMessageIfFieldEmpty(idRadiationExposureMethod,'${radiationExposureMethodRemovedWarning}'); return false;"><bean-el:message key="button.apply"/></html-el:submit></td>
                            <td><img alt=""  src="../images/buttonEndRight.gif" border="0"/></td>
                        </tr>
                    </table>
                </td>
            </tr>
        </table>
	</td>
</tr>
<tr> 
	<td class="moduleLabel"><bean-el:message key="label.environmentalContaminants" />:</td>
	<td class="moduleValue">
	        <c:set var="environmentalContaminantsLabel"><bean-el:message key="label.environmentalContaminants"/></c:set>
		<c:forEach var="item" items="${SortedIndicator}">
		    <c:if test="${item.code == IndicatorNO or item.code == IndicatorYES}">
			<html-el:radio title="${environmentalContaminantsLabel} (${item.description})" property="exposedToContaminants" styleId="idExposedToContaminants_${item.code}" value="${item.code}" disabled="${readOnlyMS}" />
			<fw:label property="exposedToContaminants" forId="idExposedToContaminants_${item.code}"><c:out value="${item.description}" />&nbsp;&nbsp;</fw:label>
		    </c:if>
		</c:forEach>
	</td> 
</tr>
</table>

<!-- MOH CCR10803 -->
<jsp:include page="newMedalOfHonor.jsp" flush="true" />

<table width="100%" border="0" cellspacing="0" cellpadding="0" class="moduleShellTableBody" role="presentation">            
<tr>
	<td class="moduleLabel"><fw:label property="shad" forId="idShad"><bean-el:message key="label.SHAD" />:</fw:label></td>
	<td width="50%" class="moduleValue">
	        <c:set var="SHADLabel"><bean-el:message key="label.SHAD"/></c:set>
		<c:forEach var="item" items="${SortedIndicator}">
		    <c:if test="${item.code == IndicatorNO or item.code == IndicatorYES}">
			<html-el:radio title="${SHADLabel} (${item.description})" property="shad" styleId="idShad_${item.code}" value="${item.code}" disabled="${readOnlyMS}"/>
			<fw:label property="shad" forId="idShad_${item.code}"><c:out value="${item.description}" />&nbsp;&nbsp;</fw:label>
		    </c:if>
		</c:forEach> 
	</td>
</tr>
</table>
<jsp:include page="campLejeune.jsp" flush="true" />
<table width="100%" border="0" cellspacing="0" cellpadding="0" class="moduleShellTableBody" role="presentation">   
<tr>
	<td class="moduleLabel"><fw:label property="filipinoVeteranProof" forId="idFilipinoVeteranProof"><bean-el:message key="label.filipinoVeteranProof" />:</fw:label></td>
	<td width="50%" class="moduleValue">
	        <c:set var="filipinoVeteranProofLabel"><bean-el:message key="label.filipinoVeteranProof"/></c:set>
		<html-el:select title="${filipinoVeteranProofLabel}" styleClass="moduleEdit" property="filipinoVeteranProof" styleId="idFilipinoVeteranProof" disabled="${readOnlyMS}">
			<html-el:option styleClass="moduleEdit" value=""><bean-el:message key="label.select" /></html-el:option>
			<esrcore:options styleClass="moduleEdit" collection="gov.va.med.esr.common.model.lookup.FilipinoVeteranProof" property="code" labelProperty="description"/> 
		</html-el:select>
	</td>
</tr>
<tr>
	<td class="moduleLabel"><bean-el:message key="label.combatVeteranEligibilityEndDate" />:</td>
	<td class="moduleValue">
		<html-el:hidden property="eligibilityEndDate" /> 
		<c:out value="${militaryServiceInfoForm.eligibilityEndDate}" />&nbsp; 
	</td>
</tr>

<tr>
	<td class="moduleLabel"><bean-el:message key="label.eligibleForClassIIDental" />:</td>
	<td class="moduleValue">
	        <c:set var="dentalClassIILabel"><bean-el:message key="label.eligibleForClassIIDental"/></c:set>
		<c:forEach var="item" items="${SortedIndicator}">
		    <c:if test="${item.code == IndicatorNO or item.code == IndicatorYES}">
			<html-el:radio title="${dentalClassIILabel} (${item.description})" property="eligibleForClassIIDental" value="${item.code}" styleId="idEligibleForClassIIDental_${item.code}" disabled="${readOnlyMS}"/>
			<fw:label property="eligibleForClassIIDental" forId="idEligibleForClassIIDental_${item.code}"><c:out value="${item.description}" />&nbsp;&nbsp;</fw:label>
		    </c:if>
		</c:forEach> 
	</td>
</tr>

<tr>
	<td class="moduleLabel"><bean-el:message key="label.classIIDentalApplicationDueBefore" />:</td>
	<td class="moduleValue">
		<html-el:hidden property="classIIDentalApplicationDueBefore" /> 
		<c:out value="${militaryServiceInfoForm.classIIDentalApplicationDueBefore}" />&nbsp; 
	</td>
</tr>

</table>
