/**
 * 
 */
package gov.va.med.esr.voa.webservice.builder.impl;

import java.util.Calendar;
import java.util.Date;

import gov.va.med.esr.common.model.lookup.AddressType;
import gov.va.med.esr.common.model.lookup.ApplicationMethod;
import gov.va.med.esr.common.model.lookup.AssetType;
import gov.va.med.esr.common.model.lookup.AssociationType;
import gov.va.med.esr.common.model.lookup.AuthenticationLevel;
import gov.va.med.esr.common.model.lookup.BenefitType;
import gov.va.med.esr.common.model.lookup.ConflictLocation;
import gov.va.med.esr.common.model.lookup.Country;
import gov.va.med.esr.common.model.lookup.DeathDataSource;
import gov.va.med.esr.common.model.lookup.DecorationStatus;
import gov.va.med.esr.common.model.lookup.DischargeType;
import gov.va.med.esr.common.model.lookup.EligibilityDocType;
import gov.va.med.esr.common.model.lookup.EmailType;
import gov.va.med.esr.common.model.lookup.EmploymentStatus;
import gov.va.med.esr.common.model.lookup.EthnicityType;
import gov.va.med.esr.common.model.lookup.ExpenseType;
import gov.va.med.esr.common.model.lookup.Gender;
import gov.va.med.esr.common.model.lookup.IncomeTestSource;
import gov.va.med.esr.common.model.lookup.IncomeTestType;
import gov.va.med.esr.common.model.lookup.IncomeType;
import gov.va.med.esr.common.model.lookup.InsurancePlanType;
import gov.va.med.esr.common.model.lookup.MaritalStatus;
import gov.va.med.esr.common.model.lookup.NameType;
import gov.va.med.esr.common.model.lookup.PhoneType;
import gov.va.med.esr.common.model.lookup.RaceType;
import gov.va.med.esr.common.model.lookup.Relationship;
import gov.va.med.esr.common.model.lookup.Religion;
import gov.va.med.esr.common.model.lookup.SSAVerificationStatus;
import gov.va.med.esr.common.model.lookup.SSNType;
import gov.va.med.esr.common.model.lookup.ServiceBranch;
import gov.va.med.esr.common.model.lookup.ServicePeriod;
import gov.va.med.esr.common.model.lookup.SpinalCordInjuryType;
import gov.va.med.esr.common.model.lookup.State;
import gov.va.med.esr.common.model.lookup.VAFacility;
import gov.va.med.esr.common.model.lookup.VAFacilityType;
import gov.va.med.esr.common.model.lookup.VOAApplicationStatus;
import gov.va.med.esr.common.model.lookup.VOAFormType;
import gov.va.med.esr.common.model.lookup.VeteranIdentifierType;
import gov.va.med.esr.service.LookupService;
import gov.va.med.fw.service.AbstractComponent;
import gov.va.med.fw.service.config.SingletonApplicationContext;


/**
 * @author DNS   CHINNR
 * 
 */
public class TypesHelper extends AbstractComponent{
	//
	private LookupService lookupService = null;

	public VeteranIdentifierType getVeteranIdentifierType(String vetType) {
		try {
			return (VeteranIdentifierType) this.getLookupService()
					.getVeteranIdentifierTypeByCode(vetType);
			/*
			 * if(vetType.equalsIgnoreCase("VPID")){ return
			 * (VeteranIdentifierType)this.getLookupService().getVeteranIdentifierTypeByCode(VeteranIdentifierType.CODE_VPID.getCode()); }
			 * if(vetType.equalsIgnoreCase("EDIPI")){ return
			 * (VeteranIdentifierType)this.getLookupService().getVeteranIdentifierTypeByCode(VeteranIdentifierType.CODE_VPID.getCode()); }
			 * if(vetType.equalsIgnoreCase("ICN")){ return
			 * (VeteranIdentifierType)this.getLookupService().getVeteranIdentifierTypeByCode(VeteranIdentifierType.CODE_VPID.getCode()); }
			 */
		} catch (Exception ex) {
		    
		  if (logger.isDebugEnabled()){
			
			logger.debug(" Type Mapping Error: VeteranIdentifierType " + ex.getMessage());
		  }
		}
		return null;
	}
	
	public NameType getNameType(String nameType) {
		try {
			return (NameType) this.getLookupService().getNameTypeByCode(nameType);
			
		} catch (Exception ex) {
			 if (logger.isDebugEnabled()){
			     logger.debug(" Type Mapping Error: getNameType " +ex.getMessage());
			 }
		}
		return null;
	}
	
	public SSNType getSSNType(String ssnType) {
		try {
			return (SSNType) this.getLookupService().getSSNTypeByCode(ssnType);
			
		} catch (Exception ex) {
			 if (logger.isDebugEnabled()){
				 logger.debug(" Type Mapping Error: getSSNType " +ex.getMessage());	
			 }
		}
		return null;
	}
	
	public InsurancePlanType getInsurancePlanType(String planType) {
		try {
			return (InsurancePlanType) this.getLookupService().getInsurancePlanTypeByCode(planType);
			
		} catch (Exception ex) {
			 if (logger.isDebugEnabled()){
				 logger.debug(" Type Mapping Error: InsurancePlanType " + ex.getMessage());	
			 }
		}
		return null;
	}
	

	public AuthenticationLevel getAuthenticationLevel(String authLevel) {
		try {
			return (AuthenticationLevel) this.getLookupService()
					.getAuthenticationLevelByCode(authLevel);
			/*
			 * if(authLevel.equalsIgnoreCase("Anonymous")){ return
			 * (AuthenticationLevel)this.getLookupService().getAuthenticationLevelByCode(AuthenticationLevel.ANONYMOUS.getCode()); }
			 * if(authLevel.equalsIgnoreCase("Assurance Level 1 (AL1)")){ //
			 * voaApp.getAuthenticationLevel().setCode("101");
			 * 
			 * return
			 * (AuthenticationLevel)this.getLookupService().getAuthenticationLevelByCode(AuthenticationLevel.ANONYMOUS.getCode());
			 *  } if(authLevel.equalsIgnoreCase("Assurance Level 2 (AL2)")){ //
			 * voaApp.getAuthenticationLevel().setCode("102");
			 * 
			 * return
			 * (AuthenticationLevel)this.getLookupService().getAuthenticationLevelByCode(AuthenticationLevel.ANONYMOUS.getCode()); }
			 * if(authLevel.equalsIgnoreCase("Assurance Level 3 (AL3)")){ //
			 * voaApp.getAuthenticationLevel().setCode("103");
			 * 
			 * return
			 * (AuthenticationLevel)this.getLookupService().getAuthenticationLevelByCode(AuthenticationLevel.ANONYMOUS.getCode());
			 *  } if(authLevel.equalsIgnoreCase("Assurance Level 4 (AL4)")){
			 * //voaApp.getAuthenticationLevel().setCode("104");
			 * 
			 * return
			 * (AuthenticationLevel)this.getLookupService().getAuthenticationLevelByCode(AuthenticationLevel.ANONYMOUS.getCode()); }
			 */
		} catch (Exception ex) {
			 if (logger.isDebugEnabled()){
				 logger.debug(" Type Mapping Error: AuthenticationLevel " +ex.getMessage());	
			 }
		}
		return null;
	}
	public State getState(String state) {
		try {
			return (State) this.getLookupService().getStateByCode(state);
					
		} catch (Exception ex) {
			 if (logger.isDebugEnabled()){
				 logger.debug(" Type Mapping Error: State " + ex.getMessage());	
			 }
		}
			return null;
	}
	public Country getCountry(String country) { 
			try {
				return (Country) this.getLookupService().getCountryByCode(country);
			} catch (Exception ex) {
				 if (logger.isDebugEnabled()){
					 logger.debug(" Type Mapping Error: Country " +ex.getMessage());	
				 }
			}
			return null;
		}
		
  public DeathDataSource getDeathDataSource(String ddata) { 
			try {
				return (DeathDataSource)this.getLookupService().getDeathDataSourceByCode(ddata);
			} catch (Exception ex) {
				 if (logger.isDebugEnabled()){
					 logger.debug(" Type Mapping Error: DeathDataSource " +ex.getMessage());	
				 }
			}
			return null;
		}
	public ApplicationMethod getApplicationMethod(String appMethod) {
		try {
			return (ApplicationMethod) this.getLookupService()
					.getApplicationMethodByCode(appMethod);
			/*
			 * if(appMethod.equalsIgnoreCase("In Person")) return
			 * (ApplicationMethod)this.getLookupService().getApplicationMethodByCode(ApplicationMethod.IN_PERSON.getCode());
			 * if(appMethod.equalsIgnoreCase("Mail")) return
			 * (ApplicationMethod)this.getLookupService().getApplicationMethodByCode(ApplicationMethod.MAIL.getCode());
			 * if(appMethod.equalsIgnoreCase("Online")) return
			 * (ApplicationMethod)this.getLookupService().getApplicationMethodByCode(ApplicationMethod.ONLINE.getCode());
			 * if(appMethod.equalsIgnoreCase("Phone")) return
			 * (ApplicationMethod)this.getLookupService().getApplicationMethodByCode(ApplicationMethod.PHONE.getCode());
			 */
		} catch (Exception ex) {
			 if (logger.isDebugEnabled()){
				 logger.debug(" Type Mapping Error: ApplicationMethod " +ex.getMessage());	
			 }
		}
		return null;
	}

	public EligibilityDocType getEligibilityDocType(String docType){
		try{
			return (EligibilityDocType)this.getLookupService().getEligibilityDocTypeByCode(docType);
		}catch(Exception ex){
			 if (logger.isDebugEnabled()){
				 logger.debug(" Type Mapping Error: EligibilityDocType "+ex.getMessage());	
			 }
		}
		return null;
	}
	public BenefitType getBenefitType(String benefitType) {
		try {
			return (BenefitType) this.getLookupService().getBenefitTypeByCode(
					benefitType);
			// return(BenefitType)this.getLookupService().getByName(BenefitType.class,
			// benefitType);
			/*
			 * 
			 * if(benefitType.equalsIgnoreCase("Dental")) return
			 * (BenefitType)this.getLookupService().getBenefitTypeByCode(BenefitType.CODE_DENTAL.getCode());
			 * if(benefitType.equalsIgnoreCase("Domiciliary")) return
			 * (BenefitType)this.getLookupService().getBenefitTypeByCode(BenefitType.CODE_DOMICILIARY.getCode());
			 * if(benefitType.equalsIgnoreCase("Enrollment")) return
			 * (BenefitType)this.getLookupService().getBenefitTypeByCode(BenefitType.CODE_ENROLLMENT.getCode());
			 * if(benefitType.equalsIgnoreCase("Health Services")) return
			 * (BenefitType)this.getLookupService().getBenefitTypeByCode(BenefitType.CODE_HEATH_SERVICES.getCode());
			 * if(benefitType.equalsIgnoreCase("Nursing Home")) return
			 * (BenefitType)this.getLookupService().getBenefitTypeByCode(BenefitType.CODE_NURSING_HOME.getCode()); //
			 * if(benefitType.equalsIgnoreCase("Outpatient Medical")) // return
			 * (BenefitType)this.getLookupService().getBenefitTypeByCode(BenefitType.CODE_OUTPATIENT_MEDICAL.getCode());
			 */
		} catch (Exception ex) {
			logger.debug(" Type Mapping Error: BenefitType " + ex.getMessage());	
		}
		return null;
	}

	public VOAFormType getVOAFormType(String formType) {

		try {
			return (VOAFormType) this.lookupService
					.getVOAFormTypeByCode(formType);
			/*
			 * if(formType.equalsIgnoreCase("1010EZ")){ return
			 * (VOAFormType)this.lookupService.getVOAFormTypeByCode(VOAFormType.VOA_FORM_1010EZ.getCode()); }
			 * 
			 * if(formType.equalsIgnoreCase("1010EZR")){ return
			 * (VOAFormType)this.lookupService.getVOAFormTypeByCode(VOAFormType.VOA_FORM_1010EZR.getCode()); }
			 * if(formType.equalsIgnoreCase("1010HS")){ return
			 * (VOAFormType)this.lookupService.getVOAFormTypeByCode(VOAFormType.VOA_FORM_1010HS.getCode()); }
			 * if(formType.equalsIgnoreCase("1010SH")){ return
			 * (VOAFormType)this.lookupService.getVOAFormTypeByCode(VOAFormType.VOA_FORM_1010SH.getCode()); }
			 * if(formType.equalsIgnoreCase("1010CG")){ return
			 * (VOAFormType)this.lookupService.getVOAFormTypeByCode(VOAFormType.VOA_FORM_1010CG.getCode()); }
			 */
		} catch (Exception ex) {
			logger.debug(" Type Mapping Error: VOAFormType "+ex.getMessage());	
		}
		return null;
	}

	public VAFacilityType getVAFacilityType(String facType) {

		try {
			return (VAFacilityType) this.getLookupService()
					.getVaFacilityTypeByCode(facType);
		} catch (Exception ex) {
			logger.debug(" Type Mapping Error: VAFacilityType "+ex.getMessage());	
		}
		return null;
	}
	public VOAApplicationStatus getVOAApplicationStatus(String appStatus) {

		try {
			return (VOAApplicationStatus) this.getLookupService().getVOAApplicationStatusByCode(appStatus);
		} catch (Exception ex) {
			logger.debug(" Type Mapping Error: VOAApplicationStatus " +ex.getMessage());	
		}
		return null;
	}
	
	public Religion getReligion(String religion) {

		try {
			return (Religion) this.getLookupService().getReligionByCode(religion);
		} catch (Exception ex) {
			logger.debug(" Type Mapping Error: Religion " + ex.getMessage());	
		}
		return null;
	}

	public VAFacility getVAFacility(String stationNumber) {

		try {
			return (VAFacility) this.getLookupService()
					.getVaFacilityByStationNumber(stationNumber);

			/*
			 * if(facType.substring(0, 3).equalsIgnoreCase("724")){
			 * return(VAFacility)this.getLookupService().getVaFacilityByCode(VAFacility.CODE_ALBUQUERQUE.getCode()); }
			 * if(facType.substring(0, 3).equalsIgnoreCase("742")){
			 * return(VAFacility)this.getLookupService().getVaFacilityByCode(VAFacility.CODE_HEC.getCode()); }
			 * if(facType.substring(0, 3).equalsIgnoreCase("200")){
			 * return(VAFacility)this.getLookupService().getVaFacilityByCode(VAFacility.CODE_MVR.getCode()); }
			 * if(facType.substring(0, 3).equalsIgnoreCase("689")){
			 * return(VAFacility)this.getLookupService().getVaFacilityByCode(VAFacility.CODE_CONNECTICUT_HCS.getCode()); }
			 * if(facType.substring(0, 5).equalsIgnoreCase("650GA")){
			 * return(VAFacility)this.getLookupService().getVaFacilityByCode(VAFacility.CODE_NEW_BEDFORD_CBOC.getCode()); }
			 * if(facType.substring(0, 3).equalsIgnoreCase("580")){
			 * return(VAFacility)this.getLookupService().getVaFacilityByCode(VAFacility.CODE_MICHAEL_E_DEBAKEY_VA_MEDICAL_CENTER.getCode()); }
			 * if(facType.substring(0, 3).equalsIgnoreCase("585")){
			 * return(VAFacility)this.getLookupService().getVaFacilityByCode(VAFacility.CODE_IRON_MOUNTAIN_VA_MEDICAL_CENTER.getCode()); }
			 * if(facType.substring(0, 3).equalsIgnoreCase("376")){
			 * return(VAFacility)this.getLookupService().getVaFacilityByCode(VAFacility.CODE_DEFAULT_CLAIM_FOLDER_LOCATION.getCode()); }
			 * if(facType.substring(0, 4).equalsIgnoreCase("200M")){
			 * return(VAFacility)this.getLookupService().getVaFacilityByCode(VAFacility.CODE_MPI_TRIGGER.getCode()); }
			 * if(facType.substring(0, 6).equalsIgnoreCase("200MH8")){
			 * return(VAFacility)this.getLookupService().getVaFacilityByCode(VAFacility.CODE_MHV.getCode()); }
			 * if(facType.substring(0, 3).equalsIgnoreCase("724")){
			 * return(VAFacility)this.getLookupService().getVaFacilityByCode(VAFacility.CODE_HEC_INCORRECT.getCode()); }
			 * 
			 */

		} catch (Exception ex) {
			logger.debug(" Type Mapping Error: VAFacility " +ex.getMessage());	
		}

		return null;
	}
	
	
	//RTC Task 236652  - added to handle code when veteran selects No to the disclose financial 
	//details option in the VOA Form
	public IncomeTestSource getIncomeTestSource(String code) {

		try {
			return (IncomeTestSource ) this.getLookupService().getIncomeTestSourceByCode(code);

		} catch (Exception ex) {
			logger.debug(" Type Mapping Error: IncomeTestSource " + ex.getMessage());	
		}

		return null;
	}	
	

	//RTC Task 236652  - added to handle code when veteran selects No to the disclose 
	//financial details from the VOA UI
	public IncomeTestType getIncomeTestType(String code) {

		try {
			return (IncomeTestType) this.getLookupService().getIncomeTestTypeByCode(code);

		} catch (Exception ex) {
			logger.debug(" Type Mapping Error: IncomeTestType " + ex.getMessage());	
		}

		return null;
	}	
	
	
	
	public Gender getGender(String gender) {
		try {
			return (Gender) (this.getLookupService().getGenderByCode(gender));
			/*
			 * if(gender.equalsIgnoreCase("Male"))
			 * return(Gender)(this.getLookupService().getGenderByCode(Gender.MALE.getCode()));
			 * if(gender.equalsIgnoreCase("Female"))
			 * return(Gender)(this.getLookupService().getGenderByCode(Gender.FEMALE.getCode()));
			 * if(gender.equalsIgnoreCase("Other"))
			 * return(Gender)(this.getLookupService().getGenderByCode(Gender.OTHER.getCode()));
			 * if(gender.equalsIgnoreCase("AMBIGUOUS"))
			 * return(Gender)(this.getLookupService().getGenderByCode(Gender.AMBIGUOUS.getCode()));
			 * if(gender.equalsIgnoreCase("UNKNOWN"))
			 * return(Gender)(this.getLookupService().getGenderByCode(Gender.UNKNOWN.getCode()));
			 * if(gender.equalsIgnoreCase("UNDIFFERENTIATED"))
			 * return(Gender)(this.getLookupService().getGenderByCode(Gender.UNDIFFERENTIATED.getCode()));
			 * if(gender.equalsIgnoreCase("NOT_APPLICABLE"))
			 * return(Gender)(this.getLookupService().getGenderByCode(Gender.NOT_APPLICABLE.getCode()));
			 */
		} catch (Exception ex) {
			logger.debug(" Type Mapping Error: Gender " +ex.getMessage());	
		} 
		return null;
	}

	public Relationship getRelationship(String relation) {
		try {
			return (Relationship) this.getLookupService()
					.getRelationshipByCode(relation);
			/*
			 * if(relation.equalsIgnoreCase("DAUGHTER"))
			 * return(Relationship)this.getLookupService().getRelationshipByCode(Relationship.CODE_DAUGHTER.getCode());
			 * if(relation.equalsIgnoreCase("SON"))
			 * return(Relationship)this.getLookupService().getRelationshipByCode(Relationship.CODE_SON.getCode());
			 * if(relation.equalsIgnoreCase("SPOUSE"))
			 * return(Relationship)this.getLookupService().getRelationshipByCode(Relationship.CODE_SPOUSE.getCode());
			 * if(relation.equalsIgnoreCase("SELF"))
			 * return(Relationship)this.getLookupService().getRelationshipByCode(Relationship.CODE_SELF.getCode());
			 * if(relation.equalsIgnoreCase("AUNT"))
			 * return(Relationship)this.getLookupService().getRelationshipByCode(Relationship.CODE_AUNT.getCode());
			 * if(relation.equalsIgnoreCase("BROTHER"))
			 * return(Relationship)this.getLookupService().getRelationshipByCode(Relationship.CODE_BROTHER.getCode());
			 * if(relation.equalsIgnoreCase("BROTHER-IN-LAW"))
			 * return(Relationship)this.getLookupService().getRelationshipByCode(Relationship.CODE_BROTHER_IN_LAW.getCode());
			 * if(relation.equalsIgnoreCase("DAUGHTER-IN-LAW"))
			 * return(Relationship)this.getLookupService().getRelationshipByCode(Relationship.CODE_DAUGHTER_IN_LAW.getCode());
			 * if(relation.equalsIgnoreCase("FATHER"))
			 * return(Relationship)this.getLookupService().getRelationshipByCode(Relationship.CODE_FATHER.getCode());
			 * if(relation.equalsIgnoreCase("FATHER-IN-LAW"))
			 * return(Relationship)this.getLookupService().getRelationshipByCode(Relationship.CODE_FATHER_IN_LAW.getCode());
			 * if(relation.equalsIgnoreCase("FOSTER DAUGHTER"))
			 * return(Relationship)this.getLookupService().getRelationshipByCode(Relationship.CODE_FOSTER_DAUGHTER.getCode());
			 * if(relation.equalsIgnoreCase("FOSTER SON"))
			 * return(Relationship)this.getLookupService().getRelationshipByCode(Relationship.CODE_FOSTER_SON.getCode());
			 * if(relation.equalsIgnoreCase("GRANDDAUGHTER"))
			 * return(Relationship)this.getLookupService().getRelationshipByCode(Relationship.CODE_GRANDDAUGHTER.getCode());
			 * if(relation.equalsIgnoreCase("GRANDFATHER"))
			 * return(Relationship)this.getLookupService().getRelationshipByCode(Relationship.CODE_GRANDFATHER.getCode());
			 * if(relation.equalsIgnoreCase("GRANDSON"))
			 * return(Relationship)this.getLookupService().getRelationshipByCode(Relationship.CODE_GRANDSON.getCode());
			 * if(relation.equalsIgnoreCase("GREAT-GRANDDAUGHTER"))
			 * return(Relationship)this.getLookupService().getRelationshipByCode(Relationship.CODE_GREATGRANDDAUGHTER.getCode());
			 * if(relation.equalsIgnoreCase("GRANDMOTHER"))
			 * return(Relationship)this.getLookupService().getRelationshipByCode(Relationship.CODE_GRANDMOTHER.getCode());
			 * if(relation.equalsIgnoreCase("GREAT-GRANDFATHER"))
			 * return(Relationship)this.getLookupService().getRelationshipByCode(Relationship.CODE_GREATGRANDFATHER.getCode());
			 * if(relation.equalsIgnoreCase("GREAT-GRANDMOTHER"))
			 * return(Relationship)this.getLookupService().getRelationshipByCode(Relationship.CODE_GREATGRANDMOTHER.getCode());
			 * if(relation.equalsIgnoreCase("GREAT-GRANDSON"))
			 * return(Relationship)this.getLookupService().getRelationshipByCode(Relationship.CODE_GREATGRANDSON.getCode());
			 * if(relation.equalsIgnoreCase("MOTHER"))
			 * return(Relationship)this.getLookupService().getRelationshipByCode(Relationship.CODE_MOTHER.getCode());
			 * if(relation.equalsIgnoreCase("MOTHER-IN-LAW"))
			 * return(Relationship)this.getLookupService().getRelationshipByCode(Relationship.CODE_MOTHER_IN_LAW.getCode());
			 * if(relation.equalsIgnoreCase("NEPHEW"))
			 * return(Relationship)this.getLookupService().getRelationshipByCode(Relationship.CODE_NEPHEW.getCode());
			 * if(relation.equalsIgnoreCase("NIECE"))
			 * return(Relationship)this.getLookupService().getRelationshipByCode(Relationship.CODE_NIECE.getCode());
			 * if(relation.equalsIgnoreCase("OTHER"))
			 * return(Relationship)this.getLookupService().getRelationshipByCode(Relationship.CODE_OTHER.getCode());
			 * if(relation.equalsIgnoreCase("SISTER"))
			 * return(Relationship)this.getLookupService().getRelationshipByCode(Relationship.CODE_SISTER.getCode());
			 * if(relation.equalsIgnoreCase("SISTER-IN-LAW"))
			 * return(Relationship)this.getLookupService().getRelationshipByCode(Relationship.CODE_SISTER_IN_LAW.getCode());
			 * if(relation.equalsIgnoreCase("SON-IN-LAW"))
			 * return(Relationship)this.getLookupService().getRelationshipByCode(Relationship.CODE_SON_IN_LAW.getCode());
			 * if(relation.equalsIgnoreCase("STEPBROTHER"))
			 * return(Relationship)this.getLookupService().getRelationshipByCode(Relationship.CODE_STEPBROTHER.getCode());
			 * if(relation.equalsIgnoreCase("STEPDAUGHTER"))
			 * return(Relationship)this.getLookupService().getRelationshipByCode(Relationship.CODE_STEPDAUGHTER.getCode());
			 * if(relation.equalsIgnoreCase("STEPFATHER"))
			 * return(Relationship)this.getLookupService().getRelationshipByCode(Relationship.CODE_STEPFATHER.getCode());
			 * if(relation.equalsIgnoreCase("STEPMOTHER"))
			 * return(Relationship)this.getLookupService().getRelationshipByCode(Relationship.CODE_STEPMOTHER.getCode());
			 * if(relation.equalsIgnoreCase("STEPSISTER"))
			 * return(Relationship)this.getLookupService().getRelationshipByCode(Relationship.CODE_STEPSISTER.getCode());
			 * if(relation.equalsIgnoreCase("STEPSON"))
			 * return(Relationship)this.getLookupService().getRelationshipByCode(Relationship.CODE_STEPSON.getCode());
			 * if(relation.equalsIgnoreCase("UNCLE"))
			 * return(Relationship)this.getLookupService().getRelationshipByCode(Relationship.CODE_UNCLE.getCode());
			 */
		} catch (Exception ex) {
			logger.debug(" Type Mapping Error: Relationship "+ ex.getMessage());	
		}
		return null;
	}

	public EmploymentStatus getEmploymentStatus(String empStatus) {
		try {
			return (EmploymentStatus) this.getLookupService()
					.getEmploymentStatusByCode(empStatus);
			/*
			 * if(empStatus.equalsIgnoreCase("Active Military Service")){
			 * return(EmploymentStatus)this.getLookupService().getEmploymentStatusByCode(EmploymentStatus.CODE_ACTIVE_MILITARYSERVICE.getCode()); }
			 * if(empStatus.equalsIgnoreCase("Employed Full-Time")){
			 * return(EmploymentStatus)this.getLookupService().getEmploymentStatusByCode(EmploymentStatus.CODE_FULL_TIME.getCode()); }
			 * if(empStatus.equalsIgnoreCase("Employed Part-Time")){
			 * return(EmploymentStatus)this.getLookupService().getEmploymentStatusByCode(EmploymentStatus.CODE_PART_TIME.getCode()); }
			 * if(empStatus.equalsIgnoreCase("Not Employed")){
			 * return(EmploymentStatus)this.getLookupService().getEmploymentStatusByCode(EmploymentStatus.CODE_NOT_EMPLOYED.getCode()); }
			 * if(empStatus.equalsIgnoreCase("Self Employed")){
			 * return(EmploymentStatus)this.getLookupService().getEmploymentStatusByCode(EmploymentStatus.CODE_SELF_EMPLOYED.getCode()); }
			 * if(empStatus.equalsIgnoreCase("Retired")){
			 * return(EmploymentStatus)this.getLookupService().getEmploymentStatusByCode(EmploymentStatus.CODE_RETIRED.getCode()); }
			 * if(empStatus.equalsIgnoreCase("Unknown")){
			 * return(EmploymentStatus)this.getLookupService().getEmploymentStatusByCode(EmploymentStatus.CODE_UNKNOWN.getCode()); }
			 * 
			 */
		} catch (Exception ex) {
			logger.debug(" Type Mapping Error: EmploymentStatus "+ex.getMessage());	
		}
		return null;
	}

	public AssociationType getAssociationType(String assoctype) {
		try {
			return (AssociationType) this.getLookupService()
					.getAssociationTypeByCode(assoctype);
			/*
			 * if(assoctype.equalsIgnoreCase("Emergency Contact")){ return
			 * (AssociationType)this.getLookupService().getAssociationTypeByCode(AssociationType.CODE_EMERGENCY_CONTACT.getCode()); }
			 * if(assoctype.equalsIgnoreCase("Primary Next of Kin")){ return
			 * (AssociationType)this.getLookupService().getAssociationTypeByCode(AssociationType.CODE_PRIMARY_NEXT_OF_KIN.getCode()); }
			 * if(assoctype.equalsIgnoreCase("Dependent")){ return
			 * (AssociationType)this.getLookupService().getAssociationTypeByCode(AssociationType.CODE_DEPENDENT.getCode()); }
			 * if(assoctype.equalsIgnoreCase("Designee")){ return
			 * (AssociationType)this.getLookupService().getAssociationTypeByCode(AssociationType.CODE_DESIGNEE.getCode()); }
			 * if(assoctype.equalsIgnoreCase("Guardian Civil")){ return
			 * (AssociationType)this.getLookupService().getAssociationTypeByCode(AssociationType.CODE_GUARDIAN_CIVIL.getCode()); }
			 * if(assoctype.equalsIgnoreCase("Guardian VA")){ return
			 * (AssociationType)this.getLookupService().getAssociationTypeByCode(AssociationType.CODE_GUARDIAN_VA.getCode()); }
			 * if(assoctype.equalsIgnoreCase("Other emergency contact")){ return
			 * (AssociationType)this.getLookupService().getAssociationTypeByCode(AssociationType.CODE_OTHER_EMERGENCY_CONTACT.getCode()); }
			 * if(assoctype.equalsIgnoreCase("Other Next of Kin")){ return
			 * (AssociationType)this.getLookupService().getAssociationTypeByCode(AssociationType.CODE_OTHER_NEXT_OF_KIN.getCode()); }
			 * if(assoctype.equalsIgnoreCase("Power of Attorney")){ return
			 * (AssociationType)this.getLookupService().getAssociationTypeByCode(AssociationType.CODE_POWER_OF_ATTORNEY.getCode()); }
			 * if(assoctype.equalsIgnoreCase("Spouse")){ return
			 * (AssociationType)this.getLookupService().getAssociationTypeByCode(AssociationType.CODE_SPOUSE.getCode()); }
			 */
		} catch (Exception ex) {
			logger.debug(" Type Mapping Error: AssociationType "+ex.getMessage());	
		}
		return null;
	}

	public AddressType getAddressType(String addType) {
		try {
			return (AddressType) this.getLookupService().getAddressTypeByCode(
					addType);
			/*
			 * if(addType.equalsIgnoreCase("Permanent")) return
			 * (AddressType)this.getLookupService().getAddressTypeByCode(AddressType.CODE_PERMANENT_ADDRESS.getCode());
			 * if(addType.equalsIgnoreCase("Birth (nee)")) return
			 * (AddressType)this.getLookupService().getAddressTypeByCode(AddressType.CODE_BIRTH_ADDRESS.getCode());
			 * if(addType.equalsIgnoreCase("Firm/Business")) return
			 * (AddressType)this.getLookupService().getAddressTypeByCode(AddressType.CODE_BUSINESS_ADDRESS.getCode());
			 * if(addType.equalsIgnoreCase("Confidential")) return
			 * (AddressType)this.getLookupService().getAddressTypeByCode(AddressType.CODE_CONFIDENTIAL_ADDRESS.getCode());
			 * if(addType.equalsIgnoreCase("Home")) return
			 * (AddressType)this.getLookupService().getAddressTypeByCode(AddressType.CODE_PRIMARY_RESIDENCE.getCode());
			 * if(addType.equalsIgnoreCase("Temporary")) return
			 * (AddressType)this.getLookupService().getAddressTypeByCode(AddressType.CODE_TEMPORARY_CORRESPONDENCE_ADDRESS.getCode());
			 */
		} catch (Exception ex) {
			logger.debug(" Type Mapping Error: AddressType "+ex.getMessage());	
		}
		return null;
	}

	public PhoneType getPhoneType(String ptype) {
		try {
			return (PhoneType) this.getLookupService()
					.getPhoneTypeByCode(ptype);
			/*
			 * if(ptype.equalsIgnoreCase("Home")){ return (PhoneType)
			 * this.getLookupService().getPhoneTypeByCode(PhoneType.CODE_HOME.getCode()); }
			 * if(ptype.equalsIgnoreCase("Mobile")){ return (PhoneType)
			 * this.getLookupService().getPhoneTypeByCode(PhoneType.CODE_MOBILE.getCode()); }
			 * if(ptype.equalsIgnoreCase("Business")){ return (PhoneType)
			 * this.getLookupService().getPhoneTypeByCode(PhoneType.CODE_BUSINESS.getCode()); }
			 * if(ptype.equalsIgnoreCase("Business")){ return (PhoneType)
			 * this.getLookupService().getPhoneTypeByCode(PhoneType.CODE_CONFIDENTIAL.getCode()); }
			 * if(ptype.equalsIgnoreCase("Business")){ return (PhoneType)
			 * this.getLookupService().getPhoneTypeByCode(PhoneType.CODE_FAX.getCode()); }
			 * if(ptype.equalsIgnoreCase("Business")){ return (PhoneType)
			 * this.getLookupService().getPhoneTypeByCode(PhoneType.CODE_INSURANCE_CARRIER_PHONE.getCode()); }
			 * if(ptype.equalsIgnoreCase("Business")){ return (PhoneType)
			 * this.getLookupService().getPhoneTypeByCode(PhoneType.CODE_PAGER.getCode()); }
			 * if(ptype.equalsIgnoreCase("Business")){ return (PhoneType)
			 * this.getLookupService().getPhoneTypeByCode(PhoneType.CODE_PRE_CERTIFICATION_PHONE.getCode()); }
			 */
		} catch (Exception ex) {
			logger.debug(" Type Mapping Error: PhoneType " +ex.getMessage());	
		}
		return null;
	}

	public EmailType getEmailType(String etype) {
		try {
			return (EmailType) this.getLookupService()
					.getEmailTypeByCode(etype);
			/*
			 * if(etype.equalsIgnoreCase("PRIVATE")){ return
			 * (EmailType)this.getLookupService().getEmailTypeByCode(EmailType.CODE_PRIVATE.getCode());
			 *  } if(etype.equalsIgnoreCase("BUSINESS")){
			 * return(EmailType)this.getLookupService().getEmailTypeByCode(EmailType.CODE_BUSINESS.getCode());
			 *  }
			 */
		} catch (Exception ex) {
			logger.debug(" Type Mapping Error: EmailType " +ex.getMessage());	
		}
		return null;
	}

	public IncomeType getIncomeType(String incomeType) {
		if (incomeType != null) {
			try {
				return (IncomeType) this.getLookupService()
						.getIncomeTypeByCode(incomeType);
				/*
				 * if(incomeType.equalsIgnoreCase("U.S. Civil Service")) return
				 * (IncomeType)this.getLookupService().getIncomeTypeByCode(IncomeType.INCOME_TYPE_CIVIL_SERVICE.getCode());
				 * if(incomeType.equalsIgnoreCase("Net Income from Farm, Ranch,
				 * Property, Business")) return
				 * (IncomeType)this.getLookupService().getIncomeTypeByCode(IncomeType.INCOME_TYPE_FARM_RANCH_PROPERTY_OR_BUSINESS_INCOME.getCode());
				 * if(incomeType.equalsIgnoreCase("Interest, Dividend,
				 * Annuity")) return
				 * (IncomeType)this.getLookupService().getIncomeTypeByCode(IncomeType.INCOME_TYPE_INTEREST_DIVIDEND_ANNUITY.getCode());
				 * if(incomeType.equalsIgnoreCase("Military Retirement")) return
				 * (IncomeType)this.getLookupService().getIncomeTypeByCode(IncomeType.INCOME_TYPE_MILITARY_RETIREMENT.getCode());
				 * if(incomeType.equalsIgnoreCase("Other Retirement")) return
				 * (IncomeType)this.getLookupService().getIncomeTypeByCode(IncomeType.INCOME_TYPE_OTHER_RETIREMENT.getCode());
				 * if(incomeType.equalsIgnoreCase("U.S. Railroad Retirement"))
				 * return
				 * (IncomeType)this.getLookupService().getIncomeTypeByCode(IncomeType.INCOME_TYPE_RAILROAD_RETIREMENT.getCode());
				 * if(incomeType.equalsIgnoreCase("Social Security (Not SSI)"))
				 * return
				 * (IncomeType)this.getLookupService().getIncomeTypeByCode(IncomeType.INCOME_TYPE_SOCIAL_SECURITY.getCode());
				 * if(incomeType.equalsIgnoreCase("All Other Income")) return
				 * (IncomeType)this.getLookupService().getIncomeTypeByCode(IncomeType.INCOME_TYPE_TOTAL_ALL_OTHER_INCOME.getCode());
				 * if(incomeType.equalsIgnoreCase("Total Employment Income
				 * (Wages, Bonuses, Tips)")) return
				 * (IncomeType)this.getLookupService().getIncomeTypeByCode(IncomeType.INCOME_TYPE_TOTAL_INCOME_FROM_EMPLOYMENT.getCode());
				 * if(incomeType.equalsIgnoreCase("Unemployment Compensation"))
				 * return
				 * (IncomeType)this.getLookupService().getIncomeTypeByCode(IncomeType.INCOME_TYPE_UNEMPLOYMENT_COMPENSATION.getCode());
				 * if(incomeType.equalsIgnoreCase("Workers Comp or Black Lung"))
				 * return
				 * (IncomeType)this.getLookupService().getIncomeTypeByCode(IncomeType.INCOME_TYPE_WORKERS_COMP_BLACK_LUNG.getCode());
				 * 
				 */
			} catch (Exception ex) {
				logger.debug(" Type Mapping Error: IncomeType "+ex.getMessage());	
			}
		}
		return null;
	}

	public AssetType getAssetType(String assetType) {
		try {
			return (AssetType) this.getLookupService().getAssetTypeByCode(
					assetType);
			/*
			 * if(assetType.equalsIgnoreCase("Cash, Amounts in Bank Accounts
			 * (CDs, IRAs, Stocks, Bonds)")) return
			 * (AssetType)this.getLookupService().getAssetTypeByCode(AssetType.CODE_CASH.getCode());
			 * if(assetType.equalsIgnoreCase("Non-Liquid Asset"))
			 * return(AssetType)this.getLookupService().getAssetTypeByCode(AssetType.CODE_NON_LIQUID_ASSET.getCode());
			 * if(assetType.equalsIgnoreCase("Other Prop (Farm, Bus) or Assets
			 * (Art, Collectibles) Less Amt Owed")) return
			 * (AssetType)this.getLookupService().getAssetTypeByCode(AssetType.CODE_OTHER.getCode());
			 * if(assetType.equalsIgnoreCase("Real Property")) return
			 * (AssetType)this.getLookupService().getAssetTypeByCode(AssetType.CODE_REAL_ESTATE.getCode());
			 * if(assetType.equalsIgnoreCase("Stocks and Bonds"))
			 * return(AssetType)this.getLookupService().getAssetTypeByCode(AssetType.CODE_STOCKS_AND_BONDS.getCode());
			 */
		} catch (Exception ex) {
			logger.debug(" Type Mapping Error: AssetType "+ex.getMessage());	
		}
		return null;
	}

	public ExpenseType getExpenseType(String expenseType) {
		try {
			return (ExpenseType) this.getLookupService().getExpenseTypeByCode(
					expenseType);
			/*
			 * if(expenseType.equalsIgnoreCase("Adjusted Medical Expense"))
			 * return
			 * (ExpenseType)this.getLookupService().getExpenseTypeByCode(ExpenseType.EXPENSE_TYPE_ADJUSTED_MEDICAL.getCode());
			 * if(expenseType.equalsIgnoreCase("Car Payment")) return
			 * (ExpenseType)this.getLookupService().getExpenseTypeByCode(ExpenseType.EXPENSE_TYPE_CAR_PAYMENT.getCode());
			 * if(expenseType.equalsIgnoreCase("Clothing")) return
			 * (ExpenseType)this.getLookupService().getExpenseTypeByCode(ExpenseType.EXPENSE_TYPE_CLOTHING.getCode());
			 * if(expenseType.equalsIgnoreCase("Veteran's Educational
			 * Expenses")) return
			 * (ExpenseType)this.getLookupService().getExpenseTypeByCode(ExpenseType.EXPENSE_TYPE_COLLEGE_AND_VOCATION.getCode());
			 * if(expenseType.equalsIgnoreCase("Child's Educational Expenses"))
			 * return
			 * (ExpenseType)this.getLookupService().getExpenseTypeByCode(ExpenseType.EXPENSE_TYPE_EDUCATIONAL_EXPENSES_BY_DEPENDENT.getCode());
			 * if(expenseType.equalsIgnoreCase("Food")) return
			 * (ExpenseType)this.getLookupService().getExpenseTypeByCode(ExpenseType.EXPENSE_TYPE_FOOD.getCode());
			 * if(expenseType.equalsIgnoreCase("Funeral and Burial Expenses"))
			 * return
			 * (ExpenseType)this.getLookupService().getExpenseTypeByCode(ExpenseType.EXPENSE_TYPE_FUNERAL_AND_BURIAL.getCode());
			 * if(expenseType.equalsIgnoreCase("Insurance")) return
			 * (ExpenseType)this.getLookupService().getExpenseTypeByCode(ExpenseType.EXPENSE_TYPE_NON_MEDICAL_INSURANCE.getCode());
			 * if(expenseType.equalsIgnoreCase("Total Non-Reimbursed Medical
			 * Expenses")) return
			 * (ExpenseType)this.getLookupService().getExpenseTypeByCode(ExpenseType.EXPENSE_TYPE_NON_REIMBURSED_MEDICAL.getCode());
			 * if(expenseType.equalsIgnoreCase("Operating Expenses Farm or
			 * Ranch")) return
			 * (ExpenseType)this.getLookupService().getExpenseTypeByCode(ExpenseType.EXPENSE_TYPE_OPERATING_EXPENSES_FOR_FARM_OR_RANCH.getCode());
			 * if(expenseType.equalsIgnoreCase("Other Expenses")) return
			 * (ExpenseType)this.getLookupService().getExpenseTypeByCode(ExpenseType.EXPENSE_TYPE_OTHER_EXPENSES.getCode());
			 * if(expenseType.equalsIgnoreCase("")) return
			 * (ExpenseType)this.getLookupService().getExpenseTypeByCode(ExpenseType.EXPENSE_TYPE_OUTSTANDING_LOAN.getCode());
			 * if(expenseType.equalsIgnoreCase("Rent/Mortgage")) return
			 * (ExpenseType)this.getLookupService().getExpenseTypeByCode(ExpenseType.EXPENSE_TYPE_RENT_MORTGAGE.getCode());
			 * if(expenseType.equalsIgnoreCase("Shelter")) return
			 * (ExpenseType)this.getLookupService().getExpenseTypeByCode(ExpenseType.EXPENSE_TYPE_SHELTER_COST.getCode());
			 * if(expenseType.equalsIgnoreCase("Child Support")) return
			 * (ExpenseType)this.getLookupService().getExpenseTypeByCode(ExpenseType.EXPENSE_TYPE_SUPPORT_DEPENDENT_CHILD.getCode());
			 * if(expenseType.equalsIgnoreCase("Spouse Support")) return
			 * (ExpenseType)this.getLookupService().getExpenseTypeByCode(ExpenseType.EXPENSE_TYPE_SUPPORT_DEPENDENT_SPOUSE.getCode());
			 * if(expenseType.equalsIgnoreCase("Taxes")) return
			 * (ExpenseType)this.getLookupService().getExpenseTypeByCode(ExpenseType.EXPENSE_TYPE_TAXES.getCode());
			 * if(expenseType.equalsIgnoreCase("Transportation")) return
			 * (ExpenseType)this.getLookupService().getExpenseTypeByCode(ExpenseType.EXPENSE_TYPE_TRANSPORTATION.getCode());
			 * if(expenseType.equalsIgnoreCase("Utilities")) return
			 * (ExpenseType)this.getLookupService().getExpenseTypeByCode(ExpenseType.EXPENSE_TYPE_UTILITIES.getCode());
			 */
		} catch (Exception ex) {
			logger.debug(" Type Mapping Error: ExpenseType " +ex.getMessage());	
		}
		return null;
	}

	public SSAVerificationStatus getSsaVerificationStatus(String ssa) {
		try {
			return (SSAVerificationStatus) this.getLookupService()
					.getSSAVerificationStatusByCode(ssa);
			/*
			 * 
			 * if(ssa.equalsIgnoreCase("In-Process")){ return
			 * (SSAVerificationStatus)this.getLookupService().getByCode(SSAVerificationStatus.class,
			 * SSAVerificationStatus.IN_PROCESS.getCode()); }
			 * if(ssa.equalsIgnoreCase("New Record")){ return
			 * (SSAVerificationStatus)this.getLookupService().getByCode(SSAVerificationStatus.class,
			 * SSAVerificationStatus.NEW_RECORD.getCode()); }
			 * if(ssa.equalsIgnoreCase("Invalid per SSA")){ return
			 * (SSAVerificationStatus)this.getLookupService().getByCode(SSAVerificationStatus.class,
			 * SSAVerificationStatus.INVALID_PER_SSA.getCode()); }
			 * if(ssa.equalsIgnoreCase("Resend to SSA")){ return
			 * (SSAVerificationStatus)this.getLookupService().getByCode(SSAVerificationStatus.class,
			 * SSAVerificationStatus.RESEND_TO_SSA.getCode()); }
			 * if(ssa.equalsIgnoreCase("Verified")){ return
			 * (SSAVerificationStatus)this.getLookupService().getByCode(SSAVerificationStatus.class,
			 * SSAVerificationStatus.VERIFIED.getCode()); }
			 */
		} catch (Exception ex) {
			logger.debug(" Type Mapping Error: SSAVerificationStatus " +ex.getMessage());	
		}
		return null;
	}

	public MaritalStatus getMaritalStatus(String mstatus) {

		try {
			return (MaritalStatus) this.getLookupService()
					.getMaritalStatusByCode(mstatus);
			/*
			 * if(mstatus.equalsIgnoreCase("Married")){ return
			 * (MaritalStatus)this.getLookupService().getByCode(MaritalStatus.class,
			 * MaritalStatus.CODE_MARRIED.getCode()); }
			 * if(mstatus.equalsIgnoreCase("Divorced")){ return
			 * (MaritalStatus)this.getLookupService().getByCode(MaritalStatus.class,
			 * MaritalStatus.CODE_DIVORCED.getCode());
			 *  } if(mstatus.equalsIgnoreCase("Never Married")){ return
			 * (MaritalStatus)this.getLookupService().getByCode(MaritalStatus.class,
			 * MaritalStatus.CODE_NEVERMARRIED.getCode());
			 *  } if(mstatus.equalsIgnoreCase("Separated")){ return
			 * (MaritalStatus)this.getLookupService().getByCode(MaritalStatus.class,
			 * MaritalStatus.CODE_SEPARATED.getCode());
			 *  } if(mstatus.equalsIgnoreCase("Unknown")){ return
			 * (MaritalStatus)this.getLookupService().getByCode(MaritalStatus.class,
			 * MaritalStatus.CODE_UNKNOWN.getCode());
			 *  } if(mstatus.equalsIgnoreCase("Widowed")){ return
			 * (MaritalStatus)this.getLookupService().getByCode(MaritalStatus.class,
			 * MaritalStatus.CODE_WIDOWED.getCode());
			 *  }
			 */
		} catch (Exception ex) {
			logger.debug(" Type Mapping Error: MaritalStatus " +ex.getMessage());	
		}
		return null;
	}

	public EthnicityType getEthnicityType(String etype) {
		try {
			return (EthnicityType) this.getLookupService()
					.getEthnicityTypeByCode(etype);
			/*
			 * if(etype.equalsIgnoreCase("Hispanic or Latino")){ return
			 * (EthnicityType)this.getLookupService().getEthnicityTypeByCode(EthnicityType.CODE_HISPANIC.getCode()); }
			 * if(etype.equalsIgnoreCase("Not Hispanic or Latino")){ return
			 * (EthnicityType)this.getLookupService().getEthnicityTypeByCode(
			 * EthnicityType.CODE_NOT_HISPANIC.getCode()); }
			 * if(etype.equalsIgnoreCase("Unknown")){ return
			 * (EthnicityType)this.getLookupService().getEthnicityTypeByCode(
			 * EthnicityType.CODE_UNKNOWN.getCode()); }
			 * if(etype.equalsIgnoreCase("Declined to answer")){ return
			 * (EthnicityType)this.getLookupService().getEthnicityTypeByCode(
			 * EthnicityType.CODE_DECLINED_ANSWER.getCode()); }
			 */
		} catch (Exception ex) {
			logger.debug(" Type Mapping Error: EthnicityType " +ex.getMessage());	
		}
		return null;
	}

	public RaceType getRaceType(String racestring) {
		try {
			return (RaceType) this.getLookupService().getRaceTypeByCode(
					racestring);
			/*
			 * if(racestring.equalsIgnoreCase("American Indian or Alaska
			 * Native")){
			 * return(RaceType)this.getLookupService().getRaceTypeByCode(RaceType.CODE_AMERICAN_INDIAN_ALASKA.getCode()); }
			 * if(racestring.equalsIgnoreCase("Asian")){
			 * return(RaceType)this.getLookupService().getRaceTypeByCode(RaceType.CODE_ASIAN.getCode()); }
			 * if(racestring.equalsIgnoreCase("Black or African American")){
			 * return(RaceType)this.getLookupService().getRaceTypeByCode(
			 * RaceType.CODE_BLACK_AFRICAN.getCode()); }
			 * if(racestring.equalsIgnoreCase("Native Hawaiian or Other Pacific
			 * Islander")){
			 * return(RaceType)this.getLookupService().getRaceTypeByCode(
			 * RaceType.CODE_HAWAIIAN_PACIFIC.getCode()); }
			 * if(racestring.equalsIgnoreCase("White")){
			 * return(RaceType)this.getLookupService().getRaceTypeByCode(
			 * RaceType.CODE_WHITE.getCode()); }
			 * if(racestring.equalsIgnoreCase("Unknown")){
			 * return(RaceType)this.getLookupService().getRaceTypeByCode(
			 * RaceType.CODE_UNKNOWN.getCode()); }
			 * if(racestring.equalsIgnoreCase("Declined to Answer")){
			 * return(RaceType)this.getLookupService().getRaceTypeByCode(
			 * RaceType.CODE_DECLINE_ANSWER.getCode()); }
			 */
		} catch (Exception ex) {
			logger.debug(" Type Mapping Error: RaceType " +ex.getMessage());	
		}
		return null;
	}

	public ServicePeriod getServicePeriod(String svcPeriod) {
		try {
			return (ServicePeriod) this.getLookupService()
					.getServicePeriodByCode(svcPeriod);
			/*
			 * if(svcPeriod.equalsIgnoreCase("AIR FORCE - ACTIVE DUTY")){ return
			 * (ServicePeriod)this.getLookupService().getServicePeriodByCode(ServicePeriod.CODE_AIR_FORCE.getCode()); }
			 * if(svcPeriod.equalsIgnoreCase("ARMY - ACTIVE DUTY")){ return
			 * (ServicePeriod)this.getLookupService().getServicePeriodByCode(ServicePeriod.CODE_ARMY.getCode()); }
			 * if(svcPeriod.equalsIgnoreCase("BENEFICIARIES-FOREIGN GOV")){
			 * return
			 * (ServicePeriod)this.getLookupService().getServicePeriodByCode(ServicePeriod.CODE_BENEFICIARIES_FOREIGN_GOV.getCode()); }
			 * if(svcPeriod.equalsIgnoreCase("CAV/NPS")){ return
			 * (ServicePeriod)this.getLookupService().getServicePeriodByCode(ServicePeriod.CODE_CAV_NPS.getCode()); }
			 * if(svcPeriod.equalsIgnoreCase("CHAMPUS RESTORE")){ return
			 * (ServicePeriod)this.getLookupService().getServicePeriodByCode(ServicePeriod.CODE_CHAMPUS_RESTORE.getCode()); }
			 * if(svcPeriod.equalsIgnoreCase("CHAMPVA - SPOUSE, CHILD")){ return
			 * (ServicePeriod)this.getLookupService().getServicePeriodByCode(ServicePeriod.CODE_CHAMPVA_SPOUSE_CHILD.getCode()); }
			 * if(svcPeriod.equalsIgnoreCase("COAST GUARD - ACTIVE DUTY")){
			 * return
			 * (ServicePeriod)this.getLookupService().getServicePeriodByCode(ServicePeriod.CODE_COAST_GUARD.getCode()); }
			 * if(svcPeriod.equalsIgnoreCase("CZECHOSLOVAKIA/POLAND SVC")){
			 * return
			 * (ServicePeriod)this.getLookupService().getServicePeriodByCode(ServicePeriod.CODE_CZECHOSLOVAKIA_POLAND_SVC.getCode()); }
			 * if(svcPeriod.equalsIgnoreCase("DONORS (NON-VET)")){ return
			 * (ServicePeriod)this.getLookupService().getServicePeriodByCode(ServicePeriod.CODE_DONORS_NON_VET.getCode()); }
			 * if(svcPeriod.equalsIgnoreCase("HUMANITARIAN (NON-VET)")){ return
			 * (ServicePeriod)this.getLookupService().getServicePeriodByCode(ServicePeriod.CODE_HUMANITARIAN_NON_VET.getCode()); }
			 * if(svcPeriod.equalsIgnoreCase("JOB CORPS/PEACE CORPS")){ return
			 * (ServicePeriod)this.getLookupService().getServicePeriodByCode(ServicePeriod.CODE_JOB_CORPS_PEACE_CORPS.getCode()); }
			 * if(svcPeriod.equalsIgnoreCase("KOREAN")){ return
			 * (ServicePeriod)this.getLookupService().getServicePeriodByCode(ServicePeriod.CODE_KOREAN.getCode()); }
			 * if(svcPeriod.equalsIgnoreCase("MEDICAL REMEDIAL ENLIST")){ return
			 * (ServicePeriod)this.getLookupService().getServicePeriodByCode(ServicePeriod.CODE_MEDICAL_REMEDIAL_ENLIST.getCode()); }
			 * if(svcPeriod.equalsIgnoreCase("MERCHANT MARINE")){ return
			 * (ServicePeriod)this.getLookupService().getServicePeriodByCode(ServicePeriod.CODE_MERCHANT_MARINE.getCode()); }
			 * if(svcPeriod.equalsIgnoreCase("MERCHANT SEAMEN - USPHS")){ return
			 * (ServicePeriod)this.getLookupService().getServicePeriodByCode(ServicePeriod.CODE_MERCHANT_SEAMEN_USPHS.getCode()); }
			 * if(svcPeriod.equalsIgnoreCase("NAVY,MARINE - ACTIVE DUTY")){
			 * return
			 * (ServicePeriod)this.getLookupService().getServicePeriodByCode(ServicePeriod.CODE_NAVY.getCode()); }
			 * if(svcPeriod.equalsIgnoreCase("OBSERVATION/EXAMINATION")){ return
			 * (ServicePeriod)this.getLookupService().getServicePeriodByCode(ServicePeriod.CODE_OBSERVATION_EXAMINATION.getCode()); }
			 * if(svcPeriod.equalsIgnoreCase("OFFICE OF WORKERS COMP.")){ return
			 * (ServicePeriod)this.getLookupService().getServicePeriodByCode(ServicePeriod.CODE_OFFICE_OF_WORKERS_COMP.getCode()); }
			 * if(svcPeriod.equalsIgnoreCase("OPERATION DESERT SHIELD")){ return
			 * (ServicePeriod)this.getLookupService().getServicePeriodByCode(ServicePeriod.CODE_OPERATION_DESERT_SHIELD.getCode()); }
			 * if(svcPeriod.equalsIgnoreCase("OTHER FEDERAL - DEPENDENT")){
			 * return
			 * (ServicePeriod)this.getLookupService().getServicePeriodByCode(ServicePeriod.CODE_OTHER_FEDERAL_DEPENDENT.getCode()); }
			 * if(svcPeriod.equalsIgnoreCase("OTHER NON-VETERANS")){ return
			 * (ServicePeriod)this.getLookupService().getServicePeriodByCode(ServicePeriod.CODE_OTHER_NON_VET.getCode()); }
			 * if(svcPeriod.equalsIgnoreCase("OTHER OR NONE")){ return
			 * (ServicePeriod)this.getLookupService().getServicePeriodByCode(ServicePeriod.CODE_OTHER_OR_NONE.getCode()); }
			 * if(svcPeriod.equalsIgnoreCase("OTHER REIMBURS. (NON-VET)")){
			 * return
			 * (ServicePeriod)this.getLookupService().getServicePeriodByCode(ServicePeriod.CODE_OTHER_REIMBURS_NON_VET.getCode()); }
			 * if(svcPeriod.equalsIgnoreCase("OTHER USPHS BENEFICIARIES")){
			 * return
			 * (ServicePeriod)this.getLookupService().getServicePeriodByCode(ServicePeriod.CODE_OTHER_USPHS_BENEFICIARIES.getCode()); }
			 * if(svcPeriod.equalsIgnoreCase("PERSIAN GULF WAR")){ return
			 * (ServicePeriod)this.getLookupService().getServicePeriodByCode(ServicePeriod.CODE_PERSIAN_GULF_WAR.getCode()); }
			 * if(svcPeriod.equalsIgnoreCase("POST-KOREAN")){ return
			 * (ServicePeriod)this.getLookupService().getServicePeriodByCode(ServicePeriod.CODE_POST_KOREAN.getCode()); }
			 * if(svcPeriod.equalsIgnoreCase("POST-VIETNAM ERA")){ return
			 * (ServicePeriod)this.getLookupService().getServicePeriodByCode(ServicePeriod.CODE_POST_VIETNAM.getCode()); }
			 * if(svcPeriod.equalsIgnoreCase("PRE-KOREAN")){ return
			 * (ServicePeriod)this.getLookupService().getServicePeriodByCode(ServicePeriod.CODE_PRE_KOREAN.getCode()); }
			 * if(svcPeriod.equalsIgnoreCase("RAILROAD RETIREMENT")){ return
			 * (ServicePeriod)this.getLookupService().getServicePeriodByCode(ServicePeriod.CODE_RAILROAD_RETIREMENT.getCode()); }
			 * if(svcPeriod.equalsIgnoreCase("RETIRED, UNIFORMED FORCES")){
			 * return
			 * (ServicePeriod)this.getLookupService().getServicePeriodByCode(ServicePeriod.CODE_RETIRED_UNIFORMED_FORCES_CODE.getCode()); }
			 * if(svcPeriod.equalsIgnoreCase("SPANISH AMERICAN")){ return
			 * (ServicePeriod)this.getLookupService().getServicePeriodByCode(ServicePeriod.CODE_SPANISH_AMERICAN.getCode()); }
			 * if(svcPeriod.equalsIgnoreCase("SPECIAL STUDIES (NON-VET)")){
			 * return
			 * (ServicePeriod)this.getLookupService().getServicePeriodByCode(ServicePeriod.CODE_SPECIAL_STUDIES_NON_VET.getCode()); }
			 * if(svcPeriod.equalsIgnoreCase("TRICARE")){ return
			 * (ServicePeriod)this.getLookupService().getServicePeriodByCode(ServicePeriod.CODE_TRICARE_CHAMPUS.getCode()); }
			 * if(svcPeriod.equalsIgnoreCase("VIETNAM ERA")){ return
			 * (ServicePeriod)this.getLookupService().getServicePeriodByCode(ServicePeriod.CODE_VIETNAM_ERA.getCode()); }
			 * if(svcPeriod.equalsIgnoreCase("WORLD WAR I")){ return
			 * (ServicePeriod)this.getLookupService().getServicePeriodByCode(ServicePeriod.CODE_WORLD_WAR_I.getCode()); }
			 * if(svcPeriod.equalsIgnoreCase("WORLD WAR II")){ return
			 * (ServicePeriod)this.getLookupService().getServicePeriodByCode(ServicePeriod.CODE_WORLD_WAR_II.getCode()); }
			 */
		} catch (Exception ex) {
			logger.debug(" Type Mapping Error: ServicePeriod " +ex.getMessage());	
		} // try
		return null;
	}

	public DischargeType getDischargeType(String dischargeType) {
		try {

			return (DischargeType) this.getLookupService()
					.getDischargeTypeByCode(dischargeType);
			/*
			 * if(dischargeType.equalsIgnoreCase("HONORABLE")){ return
			 * (DischargeType)this.getLookupService().getDischargeTypeByCode(DischargeType.CODE_HONORABLE.getCode()); }
			 * if(dischargeType.equalsIgnoreCase("DISHONORABLE")){ return
			 * (DischargeType)this.getLookupService().getDischargeTypeByCode(DischargeType.CODE_DISHONORABLE.getCode()); }
			 * if(dischargeType.equalsIgnoreCase("GENERAL")){ return
			 * (DischargeType)this.getLookupService().getDischargeTypeByCode(DischargeType.CODE_GENERAL.getCode()); }
			 * if(dischargeType.equalsIgnoreCase("OTHER THAN HONORABLE")){
			 * return
			 * (DischargeType)this.getLookupService().getDischargeTypeByCode(DischargeType.CODE_OTHER_THAN_HONORABLE.getCode()); }
			 * if(dischargeType.equalsIgnoreCase("UNDESIRABLE")){ return
			 * (DischargeType)this.getLookupService().getDischargeTypeByCode(DischargeType.CODE_UNDESIRABLE.getCode()); }
			 * if(dischargeType.equalsIgnoreCase("BAD CONDUCT")){ return
			 * (DischargeType)this.getLookupService().getDischargeTypeByCode(DischargeType.CODE_BAD_CONDUCT.getCode()); }
			 * if(dischargeType.equalsIgnoreCase("DISHONORABLE-VA")){ return
			 * (DischargeType)this.getLookupService().getDischargeTypeByCode(DischargeType.CODE_DISHONORABLE_VA.getCode()); }
			 * if(dischargeType.equalsIgnoreCase("HONORABLE-VA")){ return
			 * (DischargeType)this.getLookupService().getDischargeTypeByCode(DischargeType.CODE_HONORABLE_VA.getCode()); }
			 */
		} catch (Exception ex) {
			logger.debug(" Type Mappring Error: DischargeType "+ ex.getMessage());	
		}
		return null;
	}

	public ServiceBranch getServiceBranch(String svcbranch) {
		// Service Branch
		try {
			return ((ServiceBranch) this.getLookupService()
					.getServiceBranchByCode(svcbranch));
			/*
			 * if(svcbranch.equalsIgnoreCase("ARMY")){
			 * 
			 * return
			 * ((ServiceBranch)this.getLookupService().getServiceBranchByCode(ServiceBranch.CODE_ARMY.getCode())); }
			 * if(svcbranch.equalsIgnoreCase("AIR FORCE")){
			 * 
			 * return
			 * ((ServiceBranch)this.getLookupService().getServiceBranchByCode(ServiceBranch.CODE_AIR_FORCE.getCode())); }
			 * if(svcbranch.equalsIgnoreCase("NAVY")){
			 * 
			 * return
			 * ((ServiceBranch)this.getLookupService().getServiceBranchByCode(ServiceBranch.CODE_NAVY.getCode())); }
			 * if(svcbranch.equalsIgnoreCase("MARINE CORPS")){
			 * 
			 * return
			 * ((ServiceBranch)this.getLookupService().getServiceBranchByCode(ServiceBranch.CODE_MARINE_CORPS.getCode())); }
			 * if(svcbranch.equalsIgnoreCase("COAST GUARD")){
			 * 
			 * return
			 * ((ServiceBranch)this.getLookupService().getServiceBranchByCode(ServiceBranch.CODE_COAST_GUARD.getCode())); }
			 * if(svcbranch.equalsIgnoreCase("OTHER")){
			 * 
			 * return
			 * ((ServiceBranch)this.getLookupService().getServiceBranchByCode(ServiceBranch.CODE_OTHER.getCode())); }
			 * if(svcbranch.equalsIgnoreCase("MERCHANT SEAMAN")){
			 * 
			 * return
			 * ((ServiceBranch)this.getLookupService().getServiceBranchByCode(ServiceBranch.CODE_MERCHANT_SEAMAN.getCode())); }
			 * if(svcbranch.equalsIgnoreCase("B.E.C.")){
			 * 
			 * return
			 * ((ServiceBranch)this.getLookupService().getServiceBranchByCode(ServiceBranch.CODE_BEC.getCode())); }
			 * if(svcbranch.equalsIgnoreCase("USPHS")){
			 * 
			 * return
			 * ((ServiceBranch)this.getLookupService().getServiceBranchByCode(ServiceBranch.CODE_USPHS.getCode())); }
			 * if(svcbranch.equalsIgnoreCase("NOAA")){
			 * 
			 * return
			 * ((ServiceBranch)this.getLookupService().getServiceBranchByCode(ServiceBranch.CODE_NOAA.getCode())); }
			 * if(svcbranch.equalsIgnoreCase("F.COMMONWEALTH")){
			 * 
			 * return
			 * ((ServiceBranch)this.getLookupService().getServiceBranchByCode(ServiceBranch.CODE_F_COMMONWEALTH.getCode())); }
			 * if(svcbranch.equalsIgnoreCase("F.GUERILLA")){
			 * 
			 * return
			 * ((ServiceBranch)this.getLookupService().getServiceBranchByCode(ServiceBranch.CODE_F_GUERILLA.getCode())); }
			 * if(svcbranch.equalsIgnoreCase("F.SCOUTS NEW")){
			 * 
			 * return
			 * ((ServiceBranch)this.getLookupService().getServiceBranchByCode(ServiceBranch.CODE_F_SCOUTS_NEW.getCode())); }
			 * if(svcbranch.equalsIgnoreCase("F.SCOUTS OLD")){
			 * 
			 * return
			 * ((ServiceBranch)this.getLookupService().getServiceBranchByCode(ServiceBranch.CODE_F_SCOUTS_OLD.getCode())); }
			 * 
			 */
		} catch (Exception ex) {
			logger.debug(" Type Mappring Error: ServiceBranch " + ex.getMessage());	
		}
		return null;
	}

	public ConflictLocation getConflictLocation(String conflict) {
		try {
			return ((ConflictLocation) this.getLookupService()
					.getConflictByCode(conflict));
			/*
			 * if(conflict.equalsIgnoreCase("Conflict Unspecified")){ return
			 * ((ConflictLocation)this.getLookupService().getConflictByCode(ConflictLocation.CODE_CONFLICT_UNSPECIFIED.getCode())); }
			 * if(conflict.equalsIgnoreCase("Grenada")){ return
			 * ((ConflictLocation)this.getLookupService().getConflictByCode(ConflictLocation.CODE_CONFLICT_UNSPECIFIED.getCode())); }
			 * if(conflict.equalsIgnoreCase("Korea")){ return
			 * ((ConflictLocation)this.getLookupService().getConflictByCode(ConflictLocation.CODE_CONFLICT_UNSPECIFIED.getCode())); }
			 * if(conflict.equalsIgnoreCase("Lebanon")){ return
			 * ((ConflictLocation)this.getLookupService().getConflictByCode(ConflictLocation.CODE_CONFLICT_UNSPECIFIED.getCode())); }
			 * if(conflict.equalsIgnoreCase("OEF")){ return
			 * ((ConflictLocation)this.getLookupService().getConflictByCode(ConflictLocation.CODE_CONFLICT_UNSPECIFIED.getCode())); }
			 * if(conflict.equalsIgnoreCase("OIF")){ return
			 * ((ConflictLocation)this.getLookupService().getConflictByCode(ConflictLocation.CODE_CONFLICT_UNSPECIFIED.getCode())); }
			 * if(conflict.equalsIgnoreCase("Other")){ return
			 * ((ConflictLocation)this.getLookupService().getConflictByCode(ConflictLocation.CODE_CONFLICT_UNSPECIFIED.getCode())); }
			 * if(conflict.equalsIgnoreCase("Panama")){ return
			 * ((ConflictLocation)this.getLookupService().getConflictByCode(ConflictLocation.CODE_CONFLICT_UNSPECIFIED.getCode())); }
			 * if(conflict.equalsIgnoreCase("Persian Gulf War")){ return
			 * ((ConflictLocation)this.getLookupService().getConflictByCode(ConflictLocation.CODE_CONFLICT_UNSPECIFIED.getCode())); }
			 * if(conflict.equalsIgnoreCase("Somalia")){ return
			 * ((ConflictLocation)this.getLookupService().getConflictByCode(ConflictLocation.CODE_CONFLICT_UNSPECIFIED.getCode())); }
			 * if(conflict.equalsIgnoreCase("Unknown OEF/OIF")){ return
			 * ((ConflictLocation)this.getLookupService().getConflictByCode(ConflictLocation.CODE_CONFLICT_UNSPECIFIED.getCode())); }
			 * if(conflict.equalsIgnoreCase("Vietnam")){ return
			 * ((ConflictLocation)this.getLookupService().getConflictByCode(ConflictLocation.CODE_CONFLICT_UNSPECIFIED.getCode())); }
			 * if(conflict.equalsIgnoreCase("World War I")){ return
			 * ((ConflictLocation)this.getLookupService().getConflictByCode(ConflictLocation.CODE_CONFLICT_UNSPECIFIED.getCode())); }
			 * if(conflict.equalsIgnoreCase("World War II - Europe")){ return
			 * ((ConflictLocation)this.getLookupService().getConflictByCode(ConflictLocation.CODE_CONFLICT_UNSPECIFIED.getCode())); }
			 * if(conflict.equalsIgnoreCase("World War II - Pacific")){ return
			 * ((ConflictLocation)this.getLookupService().getConflictByCode(ConflictLocation.CODE_CONFLICT_UNSPECIFIED.getCode())); }
			 * if(conflict.equalsIgnoreCase("Yugoslavia Conflict")){ return
			 * ((ConflictLocation)this.getLookupService().getConflictByCode(ConflictLocation.CODE_CONFLICT_UNSPECIFIED.getCode())); }
			 */
		} catch (Exception ex) {
			logger.debug(" Type Mappring Error: ConflictLocation "+ex.getMessage());	
		} // try
		return null;
	}

	public DecorationStatus getDecorationStatus(String decorationStatus) {
		try {
			return (DecorationStatus) this.getLookupService()
					.getDecorationStatusByCode(decorationStatus);
			/*
			 * if(decorationStatus.equalsIgnoreCase("Confirmed")){ return
			 * (DecorationStatus)this.getLookupService().
			 * getDecorationStatusByCode(DecorationStatus.CODE_CONFIRMED.getCode()); }
			 * if(decorationStatus.equalsIgnoreCase("Pending")){ return
			 * ((DecorationStatus)this.getLookupService().
			 * getDecorationStatusByCode(DecorationStatus.CODE_PENDING.getCode())); }
			 * if(decorationStatus.equalsIgnoreCase("In Process")){ return
			 * ((DecorationStatus)this.getLookupService().
			 * getDecorationStatusByCode(DecorationStatus.CODE_IN_PROGRESS.getCode())); }
			 * if(decorationStatus.equalsIgnoreCase("Initial Ltr Sent")){ return
			 * ((DecorationStatus)this.getLookupService().
			 * getDecorationStatusByCode(DecorationStatus.CODE_INITIAL_LETTER_SENT.getCode())); }
			 * if(decorationStatus.equalsIgnoreCase("Rejected")){ return
			 * ((DecorationStatus)this.getLookupService().
			 * getDecorationStatusByCode(DecorationStatus.CODE_REJECTED.getCode())); }
			 */
		} catch (Exception ex) {
			logger.debug(" Type Mapping Error: DecorationStatus "+ ex.getMessage());	
		}
		return null;
	}

	public SpinalCordInjuryType getSpinalCordInjuryType(String spinType) {
		try {
			// sc.setDeterminationFacility(arg0);
			return ((SpinalCordInjuryType) this.getLookupService()
					.getSpinalCordInjuryTypeByCode(spinType));
			// if(spinType.equalsIgnoreCase("PARAPLEGIA TRAUMATIC"))
			// return
			// ((SpinalCordInjuryType)this.getLookupService().getSpinalCordInjuryTypeByCode(SpinalCordInjuryType.CODE_PARAPLEGIA_TRAUMATIC.getCode()));
		} catch (Exception ex) {
			logger.debug(" Type Mapping Error: SpinalCordInjuryType " + ex.getMessage());	
		}
		//
		return null;
	}
	

	public Integer getIncomeYear(){
		//The income year is current year -1 not fiscal year
	    Integer incomeYear = null;
	    Calendar calendar = Calendar.getInstance();
        calendar.setTime(new Date());   
        incomeYear = new Integer(calendar.get(Calendar.YEAR)-1);
        return incomeYear;
         
	}
	public LookupService getLookupService() {

		if (lookupService == null) {
			lookupService = (LookupService) SingletonApplicationContext
					.getInstance().getSingletonContext().getBean(
							"lookupService");
		}
		return lookupService;
	}

	public void setLookupService(LookupService lookupService) {
		this.lookupService = lookupService;
	}
}
